;
(function () {

  window._w.systemdealerview = {
    itemId: null,
    itemData: null,
    formMeta: null,
    ti: null,
    limited: false,
    newItem: false,
    ownAccount: true,
    onTemplateReady: function (template, event, eventData)
    {
      _w.systemdealerview.itemData = null;
      _w.systemdealerview.ti = _t[template];
      _w.systemdealerview.limited = ('limitedsystemdealerview' == template)
              ? true
              : false;

      App.DataStore.setData('companytypes', [
        {"value": "Limited", "label": "Limited"},
        {"value": "PTY Limited", "label": "PTY Limited"},
        {"value": "Closed Corporation", "label": "Closed Corporation"},
        {"value": "Sole Proprietor", "label": "Sole Proprietor"}
      ]);
      App.DataStore.setData('dealertypes', [
        {"value": "Dealer", "label": "Dealer"},
        {"value": "Trader", "label": "Trader"},
        {"value": "Trade Center", "label": "Trade Center"},
        {"value": "Wholesale / Trader", "label": "Wholesale / Trader"}
      ]);
      App.DataStore.setData('automatefiles', [
        {"value": "CJD", "label": "CJD"},
        {"value": "LSaker", "label": "LSaker"},
        {"value": "MultiFran", "label": "MultiFran"},
        {"value": "Toyota", "label": "Toyota"}
      ]);
      App.DataStore.setData('autolinefiles', [
        {"value": "Cargo", "label": "Cargo"},
        {"value": "Ford", "label": "Ford"},
        {"value": "GM", "label": "GM"},
        {"value": "Honda", "label": "Honda"},
        {"value": "Nissan", "label": "Nissan"}
      ]);
      App.DataStore.loadSelectListData('countries', true, 'Location', 'Country.SelectList');
      App.DataStore.loadSelectListData('groups', true, 'Company', 'Group.SelectList');
      App.DataStore.loadSelectListData('tradecenters', true, 'Company', 'Company.TradeCenterSelectList');



      _w.systemdealerview.setCompanyViewFormMeta();
      _w.systemdealerview.ti.hydrate(_w.systemdealerview.formMeta);

      // Retrieve initial view data.
      _w.systemdealerview.itemId = App.Util.getUrlParam('id');
      _w.systemdealerview.newItem = false;
      App.API.getTask(
              'updateCompany:' + _w.systemdealerview.itemId, 'Company', 'Company.AdminUpdate', _w.systemdealerview.itemId,
              {'id': _w.systemdealerview.itemId}, $.proxy(_w.systemdealerview._onCompanyViewDataReceived, this), _w.taskContractError
              );

    },
    onTemplatePublished: function (template, event, eventData)
    {
      if (null != _w.systemdealerview.itemData)
      {
        _w.systemdealerview._setupValidation();
      }
    },
    setCompanyViewFormMeta: function (data)
    {
      if (!data)
      {
        data = {};
      }
      _w.systemdealerview.formMeta = {
        'firstName': {
          type: 'input',
          id: 'firstName',
          title: 'Name',
          value: data.contact ? data.contact.firstName : ''
        },
        'familyName': {
          type: 'input',
          id: 'familyName',
          title: 'Surname',
          value: data.contact ? data.contact.familyName : ''
        },
        'office': {
          type: 'input',
          id: 'office',
          title: 'Landline',
          value: data.contact ? data.contact.office : ''
        },
        'mobile': {
          type: 'mobile',
          id: 'mobile',
          title: 'Mobile',
          value: data.contact ? data.contact.mobile : ''
        },
        'email': {
          type: 'input',
          id: 'email',
          title: 'Email',
          value: data.contact ? data.contact.email : ''
        },
        'group': {
          type: 'select',
          id: 'group',
          title: 'Group',
          dataStoreId: 'groups',
          value: data.group ? data.group.id : '',
          onChange: function () {
            if (!App.DataStore.getItem('BuildSelect:group', false))
            {
              App.DataStore.loadSelectListData(
                      'divisions', false, 'Company', 'GroupDivision.SelectList', null, {
                        Filter: {group: $(this).val()}
                      });
              App.DataStore.loadSelectListData('regionalManagers', false, 'AppConfig', 'RegionalManager.SelectList', null,
                {"Filter": {
                    "group": response.Data.group.id,
                  }});
            }
          }
        },
        'groupDivision': {
          type: 'select',
          id: 'groupDivision',
          title: 'Group division',
          dataStoreId: 'divisions',
          value: data.groupDivision ? data.groupDivision.id : ''
        },
        'name': {
          type: 'input',
          id: 'name',
          title: 'Name',
          value: data.name ? data.name : ''
        },
        'businessName': {
          type: 'input',
          id: 'businessName',
          title: 'Business name',
          value: data.businessName ? data.businessName : ''
        },
        'companyRegistrationNumber': {
          type: 'input',
          id: 'companyRegistrationNumber',
          title: 'Company Reg no',
          value: data.companyRegistrationNumber ? data.companyRegistrationNumber : ''
        },
        'vatNumber': {
          type: 'input',
          id: 'vatNumber',
          title: 'Vat no',
          value: data.vatNumber ? data.vatNumber : ''
        },
        'dealerStockNumber': {
          type: 'input',
          id: 'dealerStockNumber',
          title: 'Dealer stock no',
          value: data.dealerStockNumber ? data.dealerStockNumber : ''
        },
        'companyType': {
          type: 'select',
          id: 'companyType',
          title: 'Company type',
          dataStoreId: 'companytypes',
          value: data.companyType ? data.companyType : '',
          onChange: function () {
            if (!App.DataStore.getItem('BuildSelect:companyType', false))
            {
              if ('Sole Proprietor' == $(this).val())
              {
                $('#' + _w.systemdealerview.ti.tid + '_docCopyOfDirectorId').hide();
                $('#' + _w.systemdealerview.ti.tid + '_docCompanyRegistration').hide();
                $('#' + _w.systemdealerview.ti.tid + '_docStockCertificate').show();
                $('#' + _w.systemdealerview.ti.tid + '_docCopyOfId').show();
                $('#' + _w.systemdealerview.ti.tid + '_docAddressProof').show();
              }
              else
              {
                $('#' + _w.systemdealerview.ti.tid + '_docStockCertificate').hide();
                $('#' + _w.systemdealerview.ti.tid + '_docCopyOfId').hide();
                $('#' + _w.systemdealerview.ti.tid + '_docAddressProof').show();
                $('#' + _w.systemdealerview.ti.tid + '_docCopyOfDirectorId').show();
                $('#' + _w.systemdealerview.ti.tid + '_docCompanyRegistration').show();
              }
            }
          }
        },
        'dealerType': {
          type: 'select',
          id: 'dealerType',
          title: 'Dealer type',
          dataStoreId: 'dealertypes',
          value: data.dealerType ? data.dealerType : ''
        },
        'tradeCenter': {
          type: 'select',
          id: 'tradeCenter',
          title: 'Trade center',
          selectEmpty: 'Not assigned',
          dataStoreId: 'tradecenters',
          value: data.tradeCenter ? data.tradeCenter.id : ''
        },
        'publicCentre': {
          type: 'checkbox',
          id: 'publicCentre',
          title: 'Public Centre',
          value: data.publicCentre ? data.publicCentre : false
        },
        'priceGuide': {
          type: 'checkbox',
          id: 'priceGuide',
          title: 'Available on Price Guide invite list',
          value: data.priceGuide ? data.priceGuide : false
        },
        'regionalManager': {
          type: 'select',
          id: 'regionalManager',
          title: 'Regional Manager',
          dataStoreId: 'regionalManagers',
          value: data.regionalManager ? data.regionalManager.id : '',
        },
        'country': {
          type: 'select',
          id: 'country',
          title: 'Country',
          dataStoreId: 'countries',
          value: data.city ? data.city.region.country.id : '',
          onChange: function () {
            if (!App.DataStore.getItem('BuildSelect:country', false))
            {
              _w.systemdealerview.itemData.city.region.country.id = $('#country').val();
              _w.systemdealerview._listRegionTown();
            }
          }
        },
        'region': {
          type: 'select',
          id: 'region',
          title: 'Region',
          dataStoreId: 'regions',
          value: data.city ? data.city.region.id : '',
          onChange: function () {
            if (!App.DataStore.getItem('BuildSelect:region', false))
            {
              _w.systemdealerview.itemData.city.region.id = $('#region').val();
              _w.systemdealerview._listRegionTown();

            }
          }
        },
        'city': {
          type: 'select',
          id: 'city',
          title: 'Town',
          dataStoreId: 'cities',
          value: data.city ? data.city.id : ''
        },
        'street': {
          type: 'input',
          id: 'street',
          title: 'Street',
          value: data.street ? data.street : ''
        },
        'postalCode': {
          type: 'input',
          id: 'postalCode',
          title: 'Code',
          value: data.postalCode ? data.postalCode : ''
        },
        'docStockCertificate': {
          type: 'document',
          id: 'docStockCertificate',
          title: 'Stock certificate',
          value: data.docStockCertificate ? data.docStockCertificate : null
        },
        'docAddressProof': {
          type: 'document',
          id: 'docAddressProof',
          title: 'Proof of business address',
          value: data.docAddressProof ? data.docAddressProof : null
        },
        'docCopyOfId': {
          type: 'document',
          id: 'docCopyOfId',
          title: 'Copy of ID document',
          value: data.docCopyOfId ? data.docCopyOfId : null
        },
        'docCopyOfDirectorId': {
          type: 'document',
          id: 'docCopyOfDirectorId',
          title: 'Copy of directors ID document',
          value: data.docCopyOfDirectorId ? data.docCopyOfDirectorId : null
        },
        'docCompanyRegistration': {
          type: 'document',
          id: 'docCompanyRegistration',
          title: 'Company registration document',
          value: data.docCompanyRegistration ? data.docCompanyRegistration : null
        },
        'statusReason': {
          type: 'textarea-small',
          id: 'statusReason',
          title: 'Status reason',
          value: data.statusReason ? data.statusReason : ''
        },
        'automateFile': {
          type: 'select',
          id: 'automateFile',
          title: 'Automate File',
          dataStoreId: 'automatefiles',
          value: data.automateFile
        },
        'automateDealerCode': {
          type: 'input',
          id: 'automateDealerCode',
          title: 'Automate dealer code',
          value: data.automateDealerCode
        },
        'autolineFile': {
          type: 'select',
          id: 'autolineFile',
          title: 'Autoline file',
          dataStoreId: 'autolinefiles',
          value: data.autolineFile
        },
        'autolineDealerCode': {
          type: 'input',
          id: 'autolineDealerCode',
          title: 'Autoline dealer code',
          value: data.autolineDealerCode
        }
      };
    },
    _listRegionTown: function ()
    {
      App.DataStore.loadSelectListData(
              'regions', false, 'Location', 'Region.SelectList', null,
              {"Filter": {
                  "country": _w.systemdealerview.itemData.city.region.country.id
                }}
      );
      App.DataStore.loadSelectListData(
              'cities', false, 'Location', 'Town.SelectList', null,
              {"Filter": {
                  "region": _w.systemdealerview.itemData.city.region.id
                }}
      );
    },
    _onCompanyViewDataReceived: function (response)
    {


      _w.systemdealerview.itemId = response.Data.id;
      _w.systemdealerview.itemData = response.Data;
      //_w.systemdealerview.itemData.jobState = response.jostate;
      //console.log("testing",_w.systemdealerview.itemData.jobState );
      if (response.Data.group)
      {
        App.DataStore.loadSelectListData(
                'divisions', false, 'Company', 'GroupDivision.SelectList', null, {
                  Filter: {group: response.Data.group.id}
                });

        App.DataStore.loadSelectListData('regionalManagers', false, 'AppConfig', 'RegionalManager.SelectList', null,
                {"Filter": {
                    "group": response.Data.group.id,
                  }});
      }
      _w.systemdealerview._listRegionTown();
      _w.systemdealerview.setCompanyViewFormMeta(response.Data);
      _w.systemdealerview.ti.hydrate(_w.systemdealerview.formMeta);
      if (_w.systemdealerview.ti.published)
      {
        _w.systemdealerview._setupValidation();
      }
    },
    _setupValidation: function ()
    {
      if ('Sole Proprietor' == $('#companyType').val())
      {
        $('#' + _w.systemdealerview.ti.tid + '_docCopyOfDirectorId').hide();
        $('#' + _w.systemdealerview.ti.tid + '_docCompanyRegistration').hide();
        $('#' + _w.systemdealerview.ti.tid + '_docStockCertificate').show();
        $('#' + _w.systemdealerview.ti.tid + '_docCopyOfId').show();
        $('#' + _w.systemdealerview.ti.tid + '_docAddressProof').show();
      }
      else
      {
        $('#' + _w.systemdealerview.ti.tid + '_docStockCertificate').hide();
        $('#' + _w.systemdealerview.ti.tid + '_docCopyOfId').hide();
        $('#' + _w.systemdealerview.ti.tid + '_docAddressProof').show();
        $('#' + _w.systemdealerview.ti.tid + '_docCopyOfDirectorId').show();
        $('#' + _w.systemdealerview.ti.tid + '_docCompanyRegistration').show();
      }
      $('#frmDealerView').validate({
        rules: {
          name: {required: true},
          street: {required: true},
          postalCode: {required: true, digits: true},
          firstName: {required: true},
          familyName: {required: true},
          mobile: {required: true, mobile: true},
          office: {required: true},
          email: {required: true, email: true},
          statusReason: {maxLength: 250},
          country: "required",
          region: "required",
          city: "required"
        },
        messages: {
          email: {
            email: "Must be a valid email address."
          },
          country: "This field is required.",
          region: "This field is required.",
          city: "This field is required."
        },
        submitHandler: function (form) {
          if ('' == $('#statusReason').val())
          {
            alert('Please specify a status reason.');
            return;
          }
          $('#btnUpdate').prop('disabled', true);
          $('.dbtn').prop('disabled', true);
          var data = _w.systemdealerview._prepCompanyUpdateData();
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                  );
        }
      });
      $('#btnUpdate').prop('disabled', false);

      switch (_w.systemdealerview.itemData.jobState)
      {
        case 'New':
          $('#btnActivate').show();
          $('#btnPending').show();
          $('#btnSuspend').show();
          $('#btnDecline').show();
          $('#btnArchive').show();
          break;
        case 'Pending':
          $('#btnActivate').show();
          $('#btnSuspend').show();
          $('#btnDecline').show();
          $('#btnArchive').show();
          break;
        case 'Active':
          $('#btnSuspend').show();
          $('#btnArchive').show();
          break;
        case 'Suspended':
          $('#btnActivate').show();
          $('#btnArchive').show();
          break;
        case 'Declined':
          $('#btnActivate').show();
          $('#btnSuspend').show();
          $('#btnArchive').show();
          break;
        case 'Archived':
          $('#btnActivate').show();
          break;
      }
      $('#btnActivate').click(function () {
        if (!$('#frmDealerView').valid())
        {
          alert('Please fill in all required fields.');
          return;
        }
        if ('' == $('#statusReason').val())
        {
          alert('Please specify a status reason.');
          return;
        }
        $('#btnUpdate').prop('disabled', true);
        $('.dbtn').prop('disabled', true);
        var data = _w.systemdealerview._prepCompanyUpdateData();


        if (_w.systemdealerview.itemData.jobState == "New" || _w.systemdealerview.itemData.jobState == "Pending")
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerActive:' + _w.systemdealerview.itemId, 'Company', 'Company.MoveToActive',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );

        }
        else
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerActive:' + _w.systemdealerview.itemId, 'Company', 'Workflow.MoveToActive',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );

        }


      });
      $('#btnPending').click(function () {
        if (!$('#frmDealerView').valid())
        {
          alert('Please fill in all required fields.');
          return;
        }
        if ('' == $('#statusReason').val())
        {
          alert('Please specify a status reason.');
          return;
        }
        $('#btnUpdate').prop('disabled', true);
        var data = _w.systemdealerview._prepCompanyUpdateData();
        //console.log("test pending", _w.systemdealerview.itemData.jobState);
        if (_w.systemdealerview.itemData.jobState == "Pending" || _w.systemdealerview.itemData.jobState == "New")
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerPending:' + _w.systemdealerview.itemId, 'Company', 'Company.MoveToPending',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }
        else
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerPending:' + _w.systemdealerview.itemId, 'Company', 'Workflow.MoveToPending',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );

        }

      });
      $('#btnSuspend').click(function () {
        if (!$('#frmDealerView').valid())
        {
          alert('Please fill in all required fields.');
          return;
        }
        if ('' == $('#statusReason').val())
        {
          alert('Please specify a status reason.');
          return;
        }
        $('#btnUpdate').prop('disabled', true);
        var data = _w.systemdealerview._prepCompanyUpdateData();

        //console.log("test Suspend", _w.systemdealerview.itemData.jobState);

        if (_w.systemdealerview.itemData.jobState == "Pending")
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerSuspend:' + _w.systemdealerview.itemId, 'Company', 'Workflow.MoveToSuspended',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }


        else
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerSuspend:' + _w.systemdealerview.itemId, 'Company', 'Workflow.MoveToSuspended',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }


      });
      $('#btnDecline').click(function () {
        if (!$('#frmDealerView').valid())
        {
          alert('Please fill in all required fields.');
          return;
        }
        if ('' == $('#statusReason').val())
        {
          alert('Please specify a status reason.');
          return;
        }
        $('#btnUpdate').prop('disabled', true);

        var data = _w.systemdealerview._prepCompanyUpdateData();

        //console.log("test-declined: ", _w.systemdealerview.itemData.jobState);
        if (_w.systemdealerview.itemData.jobState == "New" || _w.systemdealerview.itemData.jobState == "Pending")
        {

          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerDeclined:' + _w.systemdealerview.itemId, 'Company', 'Company.MoveToDeclined',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }
        else
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerDeclined:' + _w.systemdealerview.itemId, 'Company', 'Workflow.MoveToDeclined',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }


      });
      $('#btnArchive').click(function () {
        if (!$('#frmDealerView').valid())
        {
          alert('Please fill in all required fields.');
          return;
        }
        if ('' == $('#statusReason').val())
        {
          alert('Please specify a status reason.');
          return;
        }
        $('#btnUpdate').prop('disabled', true);
        var data = _w.systemdealerview._prepCompanyUpdateData();

        //console.log("test Archive", _w.systemdealerview.itemData.jobState);

        if (_w.systemdealerview.itemData.jobState == "New"
                || _w.systemdealerview.itemData.jobState == "Suspended"
                || _w.systemdealerview.itemData.jobState == "Pending"
                || _w.systemdealerview.itemData.jobState == "Declined"
                || _w.systemdealerview.itemData.jobState == "Active")
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerArchived:' + _w.systemdealerview.itemId, 'Company', 'Workflow.MoveToArchive',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }
        else
        {
          App.API.execTask(
                  'updateCompany:' + _w.systemdealerview.itemId, data, {},
                  function () {
                    App.API.directRoute(
                            'routeDealerArchived:' + _w.systemdealerview.itemId, 'Company', 'Company.MoveToArchive',
                            _w.systemdealerview.itemId, {}, _w.systemdealerview._onCompanyUpdated, _w.taskExecError
                            );
                  }, _w.taskExecError
                  );
        }


      });

    },
    _prepCompanyUpdateData: function ()
    {
      var data = _w.systemdealerview.ti.harvest();
      if ('' == data.docStockCertificate)
      {
        data.docStockCertificate = null;
      }
      if ('' == data.docAddressProof)
      {
        data.docAddressProof = null;
      }
      if ('' == data.docCopyOfId)
      {
        data.docCopyOfId = null;
      }
      if ('' == data.docCopyOfDirectorId)
      {
        data.docCopyOfDirectorId = null;
      }
      if ('' == data.docCompanyRegistration)
      {
        data.docCompanyRegistration = null;
      }
      var postData = {Company: {}, Contact: {}};
      var contactFields = ["firstName", "familyName", "office", "mobile", "email"];
      for (var field in data)
      {
        if (-1 == contactFields.indexOf(field))
        {
          postData.Company[field] = data[field];
        }
        else
        {
          postData.Contact[field] = data[field];
        }
      }

      return postData;
    },
    _onCompanyUpdated: function (response)
    {
      window.location.hash = '/dealers';
    }

  };

})();