;(function(){

	window._w.systemusers = {

		itemId        : null,
		itemData      : null,
		formMeta      : null,
		offerId       : null,
		offerData     : null,
		formOfferMeta : null,
		ti            : null,
		limited       : false,
		newItem       : false,

		onTemplateReady : function( template, event, eventData )
		{
			_w.systemusers.ti = _t[template];

			_w.systemusers.initGrids();

			// User grid
			if (null == App.API.taskContract('gridSystemUser'))
			{
				App.API.getTask(
						'gridSystemUser', 'User', 'Profile.AdminGrid', null,
						{}, _w.systemusers.loadUserGrid, _w.taskContractError
						);
			}
			else
			{
				_w.systemusers.loadUserGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			$(".gridUserFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnUserSearch').click();
				}
			});

			_w.systemusers.ti = _t[template];

			// User grid
			$('#btnUserAdd').click(function() {
				window.location.hash = '/systemuserview?id=0';
			});
            $('#btnUserClearSearch').click(_w.systemusers.clearUserGridContext);
            $('#btnUserSearch').click(_w.systemusers.searchUserGrid);

		},

		exportUserGrid : function()
		{
			App.API.execTask(
					'gridSystemUser', {}, {'ExportToExcel': true},
					_w.systemusers._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
			win.document.write(response);
		},

		initGrids : function()
		{

			_w.systemusers.ti.hydrate({
				// User grid
				'gridUserTitle': 'Manage system users',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'GridExport',
							id: 'exportUserGrid',
							handler: _w.systemusers.exportUserGrid
						}
					}
				},
				'gridUserColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Company: {
							id: 'gridUserColumn_Company',
							title: 'DEALERSHIP',
							orderAsc: {
								id: 'gridUserOrder_CompanyAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_CompanyDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'company.name', 'DESC')
							}
						},
						Name: {
							id: 'gridUserColumn_Name',
							title: 'NAME',
							orderAsc: {
								id: 'gridUserOrder_NameAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.firstName', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_NameDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.firstName', 'DESC')
							}
						},
						Surname: {
							id: 'gridUserColumn_Surname',
							title: 'SURNAME',
							orderAsc: {
								id: 'gridUserOrder_SurnameAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.familyName', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_SurnameDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.familyName', 'DESC')
							}
						},
						Email: {
							id: 'gridUserColumn_Email',
							title: 'EMAIL',
							orderAsc: {
								id: 'gridUserOrder_EmailAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.email', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_EmailDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.email', 'DESC')
							}
						},
						Mobile: {
							id: 'gridUserColumn_Mobile',
							title: 'MOBILE',
							orderAsc: {
								id: 'gridUserOrder_MobileAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.mobile', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_MobileDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'profile.mobile', 'DESC')
							}
						},
						UserType: {
							id: 'gridUserColumn_UserType',
							title: 'USER TYPE',
							orderAsc: {
								id: 'gridUserOrder_UserTypeAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'permissions.name', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_UserTypeDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'permissions.name', 'DESC')
							}
						},
						AssignedTo: {
							id: 'gridUserColumn_AssignedTo',
							title: 'ASSIGNED TO',
							orderAsc: {
								id: 'gridUserOrder_AssignedToAsc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'manager.firstName', 'ASC')
							},
							orderDesc: {
								id: 'AssignedToDesc',
								bind: $.proxy(_w.systemusers.orderUserGrid, this, 'manager.firstName', 'DESC')
							}
						}
					}
				},
				'gridUserColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Company : {
							id: 'gridUserFilter_Company',
							context: 'gridUserFilter'
						},
						Name: {
							id: 'gridUserFilter_Name',
							context: 'gridUserFilter'
						},
						Surname: {
							id: 'gridUserFilter_Surname',
							context: 'gridUserFilter'
						},
						Email: {
							id: 'gridUserFilter_Email',
							context: 'gridUserFilter'
						},
						Mobile: {
							id: 'gridUserFilter_Mobile',
							context: 'gridUserFilter'
						},
						UserType: {
							id: 'gridUserFilter_UserType',
							context: 'gridUserFilter'
						},
						AssignedTo: {
							id: 'gridUserFilter_AssignedTo',
							context: 'gridUserFilter'
						}
					}
				},
				'gridUserRowRepeater': {},
				'gridUserPager': {}
			});

		},

		loadUserGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemUser', data, options,
					_w.systemusers._onUserGridDataReceived, _w.taskExecError
					);
		},

		pageUserGrid : function( page )
		{
			_w.systemusers.loadUserGrid( {}, {"Grid":{"Page":page}} );
		},

		clearUserGridContext : function()
		{
			$('.gridUserContext').val('');
			$('.gridUserFilter').val('');
			_w.systemusers.searchUserGrid();
		},

		searchUserGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Company', 'company.name');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Name', 'profile.firstName');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Surname', 'profile.familyName');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Email', 'profile.email');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Mobile', 'profile.mobile');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_UserType', 'permissions.name');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_AssignedTo', 'manager.firstName');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.systemusers.loadUserGrid( null, request, {} );
		},

		_onUserGridDataReceived : function( response )
		{
			_w.systemusers.ti.hydrateParam('gridUserRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'company.name'       : 'gridUserFilter_Company',
				'profile.firstName'  : 'gridUserFilter_Name',
				'profile.familyName' : 'gridUserFilter_Surname',
				'profile.email'      : 'gridUserFilter_Email',
				'profile.mobile'     : 'gridUserFilter_Mobile',
				'permissions.name'   : 'gridUserFilter_UserType',
				'manager.firstName'  : 'gridUserFilter_AssignedTo'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'systemuserview',
					prepend: {},
					style: {},
					items: {
						'id'         : row.id,
						'Company'    : row.company ? row.company.name : '',
						'Name'       : row.firstName,
						'Surname'    : row.familyName,
						'Email'      : row.email,
						'Mobile'     : row.mobile,
						'UserType'   : row.permissions ? row.permissions.name : '',
						'AssignedTo' : row.manager ? row.manager.firstName : ''
				}
				});
			}
			_w.systemusers.ti.hydrateParam('gridUserRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.systemusers.pageUserGrid;
			_w.systemusers.ti.hydrateParam('gridUserPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderUserGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.systemusers.loadUserGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();