;(function(){

	window._w.systemuserview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		limited : false,
		newItem : false,
		ownAccount : false,

		onTemplateReady : function( template, event, eventData )
		{
			_w.systemuserview.ti = _t[template];
			_w.systemuserview.limited = ('limitedsystemuserview' == template)
				? true
				: false;

			App.DataStore.loadSelectListData('companies', true, 'Company', 'Company.SelectList');
			App.DataStore.loadSelectListData('fullpermissions', true, 'User', 'Permissions.FullSelectList');



			_w.systemuserview.setUserViewFormMeta();
			_w.systemuserview.ti.hydrate(_w.systemuserview.formMeta);

			// Retrieve initial view data.
			_w.systemuserview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.systemuserview.itemId || null == _w.systemuserview.itemId)
			{
				_w.systemuserview.newItem = true;
				_w.systemuserview.ownAccount = false;
				_w.systemuserview.itemData = {};
				App.API.getTask(
					'createUser', 'User', 'Profile.Create',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				_w.systemuserview.ownAccount = (App.userData.id == _w.systemuserview.itemId)
					? true
					: false;
				_w.systemuserview.newItem = false;
				App.API.getTask(
					'updateUser:' + _w.systemuserview.itemId, 'User', 'Profile.Update', _w.systemuserview.itemId,
					{'id':_w.systemuserview.itemId}, $.proxy( _w.systemuserview._onUserViewDataReceived, this ), _w.taskContractError
				);
			}

		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.systemuserview.ti = _t[template];
			if (_w.systemuserview.newItem)
			{
				_w.systemuserview._setupValidation();
			}
			$('#btnResetPin').click(function() {
				App.API.getTask(
						'PinReset:' + _w.systemuserview.itemId, 'User', 'Profile.ForgotPassword', null,
						{}, function () {
							App.API.execTask(
									'PinReset:' + _w.systemuserview.itemId, {
										Reset : {
											email : _w.systemuserview.itemData.email
										}
								}, {},
								function() {
									alert('Pin reset successfull.');
								}, _w.taskExecError
							);
						}, _w.taskContractError
				);
			});
			$('#btnSuspend').click(_w.systemuserview._routeToSuspended);
			$('#btnActivate').click(_w.systemuserview._routeToActive);
			$('#btnArchive').click(_w.systemuserview._routeToArchived);
			$('#btnUnarchive').click(_w.systemuserview._routeToActive);
			if (!_w.systemuserview.newItem)
			{
				$('#btnPermissions').click(function() {
					window.location.hash = '/override?id=' + _w.systemuserview.itemData.override;
				});
			}
			else
			{
				$('#btnPermissions').prop('disabled', true);
			}
		},

		_routeToActive : function()
		{
			App.API.directRoute(
				'routeUserActive:' + _w.systemuserview.itemId, 'User', 'Workflow.MoveToActive',
				_w.systemuserview.itemId, {}, _w.systemuserview._onUserUpdated, _w.taskExecError
			);
		},

		_routeToSuspended : function()
		{
			App.API.directRoute(
				'routeUserSuspended:' + _w.systemuserview.itemId, 'User', 'Workflow.MoveToSuspended',
				_w.systemuserview.itemId, {}, _w.systemuserview._onUserUpdated, _w.taskExecError
			);
		},

		_routeToArchived : function()
		{
			App.API.directRoute(
				'routeUserArchive:' + _w.systemuserview.itemId, 'User', 'Workflow.MoveToArchive',
				_w.systemuserview.itemId, {}, _w.systemuserview._onUserUpdated, _w.taskExecError
			);
		},

		setUserViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.systemuserview.formMeta = {
				'company' : {
					type        : 'select',
					id          : 'company',
					title       : 'Dealership',
					dataStoreId : 'companies',
					value       : data.company ? data.company : '',
					onChange    : function() {
						if (!App.DataStore.getItem('BuildSelect:company', false))
						{
							App.DataStore.loadSelectListData('cmpfltrdmanagers', false, 'User', 'Profile.AdminManagerList', null, {
								Filter: {company: $(this).val()}
							});
						}
					}
				},
				'firstName' : {
					type  : 'input',
					id    : 'firstName',
					title : 'Name',
					value : data.firstName ? data.firstName : '',
					maxlength : 100
				},
				'familyName' : {
					type  : 'input',
					id    : 'familyName',
					title : 'Surname',
					value : data.familyName ? data.familyName : '',
					maxlength : 100
				},
				'idNumber' : {
					type  : 'input',
					id    : 'idNumber',
					title : 'ID Number',
					value : data.idNumber ? data.idNumber : '',
					maxlength : 13,
					onChange  : function() {
						var dig = $(this).val().substring(0, 6);
						$('#dateOfBirth').val(
								'19' + dig.substring(0, 2) +
								'-' + dig.substring(2, 4) +
								'-' + dig.substring(4, 6)
								);
					}
				},
				'dateOfBirth' : {
					type  : 'input',
					id    : 'dateOfBirth',
					title : 'Date of birth',
					style : 'datepicker',
					value : data.dateOfBirth ? data.dateOfBirth : ''
				},
				'mobile' : {
					type  : 'mobile',
					id    : 'mobile',
					title : 'Mobile',
					value : data.mobile ? data.mobile : '',
					maxlength : 20
				},
				'email' : {
					type  : 'input',
					id    : 'email',
					title : 'Email',
					value : data.email ? data.email : '',
					maxlength : 255
				},
				'manager' : {
					type        : 'select',
					id          : 'manager',
					title       : 'Assign to',
					selectEmpty : 'Nobody',
					dataStoreId : 'cmpfltrdmanagers',
					value       : data.manager ? data.manager : ''
				},
				'permissions' : {
					type        : 'select',
					id          : 'permissions',
					title       : 'User type',
					dataStoreId : 'fullpermissions',
					value       : data.permissions ? data.permissions : ''
				},
				
				'mainMemberPublicCentre' : {
					type  : 'checkbox',
					id    : 'mainMemberPublicCentre',
					title : 'Main Member of Public Centre',
					value : data.mainMemberPublicCentre ? data.mainMemberPublicCentre : false
				},

				'subscribeNewsletter' : {
					type  : 'checkbox',
					id    : 'subscribeNewsletter',
					title : 'Subscribe to newsletters',
					value : data.subscribeNewsletter ? data.subscribeNewsletter : false
				}
			};
		},

		_onUserViewDataReceived : function( response )
		{
			if (response.Data.company)
			{
				App.DataStore.loadSelectListData('cmpfltrdmanagers', false, 'User', 'Profile.AdminManagerList', null, {
					Filter: {company: response.Data.company}
				});
			}
			else
			{
				App.DataStore.setData('managers', []);
			}
			_w.systemuserview.itemId = response.Data.id;
			_w.systemuserview.itemData = response.Data;
			_w.systemuserview.setUserViewFormMeta(response.Data);
			_w.systemuserview.ti.hydrate(_w.systemuserview.formMeta);
			if (!_w.systemuserview.newItem)
			{
				switch (response.Data.jobState)
				{
				case 'Active':
					$('#btnResetPin').show();
					$('#btnSuspend').show();
					$('#btnArchive').show();
					break;
				case 'Suspended':
					$('#btnActivate').show();
					$('#btnArchive').show();
					break;
				case 'Archived':
					$('#btnUnarchive').show();
					break;
				}
			}
			_w.systemuserview._setupValidation();
		},

		_setupValidation : function ()
		{
			$('#frmUserView').validate({
				"rules": {
					firstName: "required",
					familyName: "required",
					idNumber: {required: true, minlength: 13, maxlength: 13, digits: true},
					dateOfBirth: {required: true, dateISO: true},
					mobile: {required: true, mobile: true},
					email: {
						required: true,
						email: true,
						remote: {
							url: "/workspace/validate-unique-field-direct",
							type: "post",
							data: {
								Workspace 	: 'User',
								Group 		: 'Profile',
								Label 		: 'Email',
								Field 		: 'email',
								Value 		: function() {
									return $("#email").val();
								},
								Id 			: $.proxy(function() {
									return _w.systemuserview.itemId;
								}, this)
							}
						}
					},
					permissions: "required"
				},
				messages: {
					firstName : "This field is required.",
					familyName : "This field is required.",
					email: {
						email: "Must be a valid email address."
					},
					idNumber: {
						minlength: "Must be 13 digits.",
						maxlength: "Must be 13 digits."
					},
					dateOfBirth: {
						dateISO: "Must be a valid date."
					},
					permissions : "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.systemuserview._prepUserUpdateData();
					if (_w.systemuserview.newItem)
					{
						App.API.execTask(
								'createUser', data, {},
								_w.systemuserview._onUserUpdated, _w.taskExecError
							);
					}
					else
					{
						App.API.execTask(
								'updateUser:' + _w.systemuserview.itemId, data, {},
								_w.systemuserview._onUserUpdated, _w.taskExecError
							);
					}
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepUserUpdateData : function()
		{
			var data = {Profile:_w.systemuserview.ti.harvest()};
			if ('' == data.Profile.manager)
			{
				data.Profile.manager = null;
			}
			return data;
		},

		_onUserUpdated : function( response )
		{
			if (_w.systemuserview.ownAccount)
			{
				App.API.getTask(
						'updateOffer:' + _w.offerview.offerId, 'User', 'Profile.ActiveAccount', null,
						{}, function (response) {
							App.permissions = response.Data.permissions;
							delete response.Data.permissions;
							App.companyData = response.Data.company;
							delete response.Data.company;
							App.userData = response.Data;
							window.location.hash = '/systemusers';
						}, _w.onActiveAccountFailure
					);
			}
			else
			{
				window.location.hash = '/systemusers';
			}
		}

	};

})();