;(function(){

    window._w.customervaluation = {

        itemId : null,
        itemData : null,
        formMeta : null,
        ti : null,
        limited : false,
        newItem : false,
        validations : 0,
        highestOfferId : false,
        priceGuideId : false,
        publicCentreList : {},
        currentStep : 1,

        onCustomerValuationViewTemplateReady : function( template, event, eventData )
        {
            _w.customervaluation.itemData = null;
            _w.customervaluation.ti = _t[template];
            _w.customervaluation.limited = false;

            _w.customervaluation.setValuationViewFormMeta();
            // Retrieve initial view data.
            _w.customervaluation.itemId = 0;

            _w.customervaluation.newItem = true;
            _w.customervaluation.itemData = {stock:{}};
        },

        onCustomerValuationViewPublished : function( template, event, eventData )
        {

            App.DataStore.loadSelectListData(
                'years', false, 'Stock', 'Year.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'categories', false, 'Stock', 'Category.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'fuelTypes', false, 'Stock', 'FuelType.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'transmissionTypes', false, 'Stock', 'TransmissionType.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'fsh', false, 'Stock', 'FullServiceHistory.SelectList', null,
                {}
            );

            App.DataStore.loadSelectListData(
                'regions', false, 'Location', 'Region.SelectListNames', null,
                {"Filter": {
                    "country" 	: 1,
                    "name" 		: ['Gauteng','Western Cape','KwaZulu-Natal']
                }}
            );

            App.API.getTask(
                'publicCentreList', 'Company', 'Company.SelectGrid', null, {},
                $.proxy(function()
                {
                    App.API.execTask(
                        'publicCentreList', {}, {},
                        $.proxy(function(response)
                        {
                            _w.customervaluation.publicCentreList = {};
                            for (var i in response.Data.DataSet)
                            {
                                var company = response.Data.DataSet[i];
                                if (undefined == _w.customervaluation.publicCentreList[company.city.region.id])
                                {
                                    _w.customervaluation.publicCentreList[company.city.region.id] = [];
                                }
                                _w.customervaluation.publicCentreList[company.city.region.id].push({
                                    value: company.id,
                                    label: company.name
                                });
                            }
                        }, this),
                        _w.taskExecError
                    );
                }, this),
                _w.taskContractError
            );



            App.API.getTask(
                'createCustomerValuation', 'Valuation', 'Valuation.CreateCustomerPublic',
                null, {}, function(){}, _w.taskContractError
            );

            App.DataStore.setData('sparekeys', [{"value":"1", "label":"Yes"}, {"value":"0", "label":"No"}]);


            // Do a check here for the ie browser - if ie show upload file buttons
            // IE browsers prevent submitting files when the input field didn't receive a direct click

            if(navigator.appVersion.indexOf("MSIE ")!=-1)
            {
                $('#terms').parent().addClass("IE");
            }



            _w.customervaluation.limited = false;
            _w.customervaluation._setupValidation();

            $('.back-btn').on('click', function(){
                window.history.back();
            });

            $('#btnContinue1').click(function () {

                $('.btn-next').click();
            });

            $('#btnContinue2').click(function () {

                $('.btn-next').click();
            });

            $('#btnContinue3').click(function () {

                var rules1 = {
                    firstName: {required: true, minlength: 3},
                    familyName: {required: true, minlength: 3},
                    email: {required: true, email: true},
                    confirmEmail: {required: true, email: true, equalTo: "#email"},
                    mobile: {required: true, mobile: true},
                    region: {required: true},
                    city: {required: false},
                    publicCentre: {required: true},
                    street: {required: false},
                    requiredPrice: {required: true, number: true, min: 0.01},
                    vehicleYear: "required",
                    vehicleCategory: "required",
                    vehicleMake: "required",
                    vehicleModel: "required",
                    vehicleType: "required",
                    vehicleFuelType: "required",
                    vehicleTransmissionType: "required",
                    registrationNumber: "required",
                    fullServiceHistory: "required",
                    km: { required: true, digits: true }
                };
                $('#frmCustomerValuationView').validate({
                    "rules": rules1,
                    messages: {
                        firstName: {
                            minlength: "This field is required."
                        },
                        familyName: {
                            minlength: "This field is required."
                        },
                        email: {
                            required: "This field is required.",
                            email: "Please enter a valid<br/>email address."
                        },
                        confirmEmail: {
                            required: "This field is required.",
                            email: "Please enter a valid<br/>email address.",
                            equalTo: "Please enter the same<br/>value again."
                        },
                        requiredPrice: {
                            required: "This field is required.",
                            number: "Please enter a valid amount.",
                            min: "Please enter a<br/>valid amount."
                        },
                        vehicleYear : "This field is required.",
                        vehicleCategory : "This field is required.",
                        vehicleMake : "This field is required.",
                        vehicleModel : "This field is required.",
                        vehicleType : "This field is required.",
                        vehicleFuelType : "This field is required.",
                        vehicleTransmissionType : "This field is required.",
                        fullServiceHistory : "This field is required.",
                        registrationNumber : "This field is required.",
                        km : {required: "This field is required."}
                    },
                    invalidHandler: function(event, validator) {
                        var errors = validator.numberOfInvalids();
                        if (0 < _w.customervaluation.validations && errors) {
                            var message = errors == 1
                                ? 'You missed 1 field. It has been highlighted'
                                : 'You missed ' + errors + ' fields. They have been highlighted';
                            alert(message);
                        }
                        _w.customervaluation.validations++;
                    },
                    submitHandler: function( form ) {
                        return;
                    }
                });
                try {
                    _w.customervaluation.validations = 0;
                    var formValid = $('#frmCustomerValuationView').valid();

                    if(formValid)
                    {
                        var confirmationOfvehicleYear = $('#vehicleYear option:selected').text();
                        var confirmationOfcategory = $('#vehicleCategory option:selected').text();
                        var confirmationOfmake = $('#vehicleMake option:selected').text();
                        var confirmationOfmodel = $('#vehicleModel option:selected').text();
                        var confirmationOftype = $('#vehicleType option:selected').text();
                        var confirmationOffullServiceHistory = $('#fullServiceHistory option:selected').text();
                        var confirmationOffuelType = $('#vehicleFuelType option:selected').text();
                        var confirmationOftransmissionType = $('#vehicleTransmissionType option:selected').text();
                        var confirmationOfkm = $('#km').val();
                        var confirmationOfregistrationNumber = $('#registrationNumber').val();
                        var confirmationOffirstName = $('#firstName').val();
                        var confirmationOffamilyName = $('#familyName').val();
                        var confirmationOfmobile = $('#mobile').val();
                        var confirmationOfemail = $('#email').val();
                        var confirmationOfregion = $('#region option:selected').text();
                        var confirmationOfpublicCentre = $('#publicCentre option:selected').text();
                        var confirmationOfrequiredPrice = $('#requiredPrice').val();

                        //var confirmationOfInfoHtml =
                        //    '<div class="span5 offset1">'
                        //    + '<h4>Customer information:<h4>'
                        //    + '<br>'
                        //    + '<h5>' + confirmationOffirstName + ' ' + confirmationOffamilyName + '<h5>'
                        //    + '<br>'
                        //    + '<h5>' + confirmationOfmobile + '<h5>'
                        //    + '<br>'
                        //    + '<h5>' + confirmationOfemail + '<h5>'
                        //    + '</div>'
                        //    + '<div class="span6">'
                        //    + '<h4>Vehicle Information:<h4>'
                        //    + '<br>'
                        //    + '<h5>' + confirmationOfvehicleYear + '<h5>'
                        //    + '<h5>' + confirmationOfmake + '<h5>'
                        //    + '<h5>' + confirmationOfmodel + '<h5>'
                        //    + '<h5>' + confirmationOftype + '<h5>'
                        //    + '<h5>' + confirmationOfkm + ' Kms<h5>'
                        //    + '<h5>' + confirmationOfregistrationNumber + '<h5>'
                        //    + '<h5>' + confirmationOffuelType + '<h5>'
                        //    + '<h5>' + confirmationOftransmissionType + '<h5>'
                        //    + '<br>'
                        //    + '</div>';

                        var confirmationOfInfoHtml =
                            '<div class="span5">'
                            + '<h4><u>Customer information:</u><h4>'
                            + '<br>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Customer: </span>'
                            + '<span class="text-h5 span8">' + confirmationOffirstName + ' ' + confirmationOffamilyName + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Cell Number: </span>'
                            + '<span class="text-h5 span8">+27' + confirmationOfmobile + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Email: </span>'
                            + '<span class="text-h5 span8">' + confirmationOfemail + '</span>'
                            + '</div>'
                            + '</div>'
                            + '<div class="span6">'
                            + '<h4><u>Vehicle Information:</u><h4>'
                            + '<br>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Year: </span>'
                            + '<span class="text-h5 span8">' + confirmationOfvehicleYear + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Make: </span>'
                            + '<span class="text-h5 span8">' + confirmationOfmake + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Model: </span>'
                            + '<span class="text-h5 span8">' + confirmationOfmodel + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Mileage: </span>'
                            + '<span class="text-h5 span8">' + confirmationOfkm + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Registration: </span>'
                            + '<span class="text-h5 span8">' + confirmationOfregistrationNumber + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Transmission: </span>'
                            + '<span class="text-h5 span8">' + confirmationOftransmissionType + '</span>'
                            + '</div>'
                            + '<div class="span12">'
                            + '<span class="text-h4 span4">Fuel Type: </span>'
                            + '<span class="text-h5 span8">' + confirmationOffuelType + '</span>'
                            + '</div>'
                            + '<br>'
                            + '</div>';


                        $('#confirmationOfInfo').html(confirmationOfInfoHtml);

                        $('.btn-next').click();
                    }

                } catch(err) {}
                $('label.error').remove();
                $('.valid').removeClass('valid');


            });

            $('#terms').change($.proxy(function () {

                console.log('terms checked',$('#terms').is(':checked'));

                if($('#terms').is(':checked'))
                {
                    $('#btnContinue4').prop('disabled', false);
                }
                else
                {
                    $('#btnContinue4').prop('disabled', true);
                }
            }, this));


            $('#btnContinue4').click(function () {
                //$('#frmCustomerValuationView').submit();
                _w.customervaluation._setupValidation();

                var data = _w.customervaluation._prepValuationUpdateData();
                App.API.execTask(
                    'createCustomerValuation', data, {},
                    _w.customervaluation._onValuationUpdated,
                    _w.customervaluation._onValuationFail
                );
            });
            $('.btn-prev').click($.proxy(function () {
                _w.customervaluation.currentStep--;
            }, this));
            $('.btn-next').click($.proxy(function () {
                $('.btn-next').prop('disabled', true);
                _w.customervaluation.currentStep++;
                _w.customervaluation.validatePage(_w.customervaluation.currentStep);
            }, this));
            $('.btn-next').prop('disabled', true);
            $('#btnContinue1').prop('disabled', true);
            $('#btnContinue4').prop('disabled', true);


            _w.customervaluation.ti.hydrate(_w.customervaluation.formMeta);

        },

        validatePage : function(step)
        {
            var errors = false;

            switch (step)
            {
                case 1:
                    var fields = {
                        '#vehicleYear': true,
                        '#vehicleCategory': true,
                        '#vehicleMake': true,
                        '#vehicleModel': true,
                        '#vehicleType': true
                    };
                    break;
                case 2:
                    var fields = {
                        '#vehicleFuelType': true,
                        '#vehicleTransmissionType': true,
                        '#fullServiceHistory': true,
                        '#km': true
                    };
                    break;
                case 3:
                    var fields = {
                        '#firstName': true,
                        '#familyName': true,
                        '#email': true,
                        '#mobile': true,
                        '#region': true,
                        '#publicCentre': true
                    };
                    break;
            }


            for (var field in fields)
            {
                if ('' !== $(field).val() && null !== $(field).val())
                {
                    if (!$(field).valid())
                    {
                        $('.btn-next').prop('disabled', true);
                        $('#btnContinue' + step).prop('disabled', true);
                        return;
                    }
                }
                else if (fields[field])
                {
                    $('.btn-next').prop('disabled', true);
                    $('#btnContinue' + step).prop('disabled', true);
                    return;
                }

            }

            if(4 != step)
            {
                $('.btn-next').prop('disabled', false);
                $('#btnContinue' + step).prop('disabled', false);
            }

            //$('.btn-next').prop('disabled', false);
            //$('#btnContinue' + step).prop('disabled', false);

        },

        setValuationViewFormMeta : function()
        {
            data = {"stock":{}};
            _w.customervaluation.formMeta = {
                'vehicleYear' : {
                    type        : 'select',
                    id          : 'vehicleYear',
                    title       : 'Year',
                    dataStoreId : 'years',
                    value       : data.stock.vehicleYear ? data.stock.vehicleYear : '',
                    onChange    : function (evt) {
                        if (!App.DataStore.getItem('BuildSelect:vehicleYear', false))
                        {
                            _w.customervaluation._listMakesModelsTypes();
                        }
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(1);
                    }
                },
                'category' : {
                    type        : 'select',
                    id          : 'vehicleCategory',
                    title       : 'Category',
                    dataStoreId : 'categories',
                    value       : data.stock.type ? data.stock.type.category.id : '',
                    onChange    : function (evt) {
                        if (!App.DataStore.getItem('BuildSelect:vehicleCategory', false))
                        {
                            _w.customervaluation._listMakesModelsTypes();
                        }
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(1);
                    }
                },
                'make' : {
                    type        : 'select',
                    id          : 'vehicleMake',
                    title       : 'Vehicle Make',
                    dataStoreId : 'makes',
                    value       : data.stock.type ? data.stock.type.model.make.id : '',
                    onChange    : function (evt) {
                        if (!App.DataStore.getItem('BuildSelect:vehicleMake', false))
                        {
                            _w.customervaluation._listMakesModelsTypes();
                        }
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(1);
                    }
                },
                'model' : {
                    type        : 'select',
                    id          : 'vehicleModel',
                    title       : 'Vehicle Model',
                    dataStoreId : 'models',
                    value       : data.stock.type ? data.stock.type.model.id : '',
                    onChange    : function (evt) {
                        if (!App.DataStore.getItem('BuildSelect:vehicleModel', false))
                        {
                            _w.customervaluation._listMakesModelsTypes();
                        }
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(1);
                    }
                },
                'type' : {
                    type        : 'select',
                    id          : 'vehicleType',
                    title       : 'Vehicle Type',
                    dataStoreId : 'types',
                    value       : data.stock.type ? data.stock.type.id : '',
                    onChange    : function (evt) {
                       var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        App.API.getTask(
                            'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
                            {}, _w.customervaluation._onTuReady, _w.taskContractError
                        );
                        App.API.getTask(
                            'GetMmCode' + $(this).val(), 'Stock', 'Type.GetMmCode', null,
                            {id:$(this).val()}, function(response){
                                $('#mmCode').html(response.Data.mmCode);
                            }, _w.taskContractError
                        );
                        _w.customervaluation.validatePage(1);
                    }
                },


                'fuelType' : {
                    type        : 'select',
                    id          : 'vehicleFuelType',
                    title       : 'Fuel Type',
                    dataStoreId : 'fuelTypes',
                    value       : data.stock.fuelType ? data.stock.fuelType : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(2);
                    }
                },
                'transmissionType' : {
                    type        : 'select',
                    id          : 'vehicleTransmissionType',
                    title       : 'Transmission Type',
                    dataStoreId : 'transmissionTypes',
                    value       : data.stock.transmissionType ? data.stock.transmissionType : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(2);
                    }
                },
                'registrationNumber' : {
                    type  : 'input',
                    id    : 'registrationNumber',
                    title : 'Registration no',
                    value : data.stock.registrationNumber ? data.stock.registrationNumber : '',
                    style	: 'capitalise',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(2);
                    }
                },
                'km' : {
                    type  : 'input',
                    id    : 'km',
                    title : 'Kms',
                    value : data.stock.km ? data.stock.km : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(2);
                    },
                    onKeyUp : function (evt) { _w.customervaluation.validatePage(2);}
                },
                'fullServiceHistory' : {
                    type        : 'select',
                    id          : 'fullServiceHistory',
                    title       : 'Full service history',
                    dataStoreId : 'fsh',
                    value       : data.stock.fullServiceHistory ? data.stock.fullServiceHistory : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(2);
                    }
                },

                'firstName' : {
                    type  : 'input',
                    id    : 'firstName',
                    title : 'Name',
                    value : data.firstName ? data.firstName : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },
                'familyName' : {
                    type  : 'input',
                    id    : 'familyName',
                    title : 'Surname',
                    value : data.familyName ? data.familyName : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },
                'email' : {
                    type  : 'input',
                    id    : 'email',
                    title : 'Email address',
                    value : data.email ? data.email : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },
                'confirmEmail' : {
                    type  : 'input',
                    id    : 'confirmEmail',
                    title : 'Confirm email address',
                    value : '',
                    maxlength : 255
                },
                'mobile' : {
                    type  : 'mobile',
                    id    : 'mobile',
                    title : 'Mobile',
                    value : data.mobile ? data.mobile : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },
                'region' : {
                    type        : 'select',
                    id          : 'region',
                    title       : 'Region',
                    dataStoreId : 'regions',
                    value       : '',
                    onChange    : $.proxy(function (evt) {
                        if (!App.DataStore.getItem('BuildSelect:region', false))
                        {
                            /*App.DataStore.loadSelectListData(
                             'cities', false, 'Location', 'Town.SelectList', null,
                             {"Filter": {
                             "region" : $(this).val()
                             }}
                             );*/

                            var dataList = undefined != _w.customervaluation.publicCentreList[$('#region').val()]
                                ? _w.customervaluation.publicCentreList[$('#region').val()]
                                : [];
                            App.DataStore.setData('publicCentre', dataList);
                            if ($('#sameAsBusinessAddress').prop('checked'))
                            {
                                $('#billingRegion').selectpicker('val', $('#region').val());
                            }

                            var value = $(evt.currentTarget).val();
                            if (null == value || '' == value)
                            {
                                return;
                            }
                            _w.customervaluation.validatePage(3);
                        }
                    }, this)
                },
                'city' : {
                    type        : 'select',
                    id          : 'city',
                    title       : 'Town',
                    dataStoreId : 'cities',
                    value       : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },

                'publicCentre' : {
                    type        : 'select',
                    id          : 'publicCentre',
                    title       : 'Public Center',
                    dataStoreId : 'publicCentre',
                    value       : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },


                'street' : {
                    type  : 'input',
                    id    : 'street',
                    title : 'Street',
                    value : '',
                    maxlength : 75,
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                },
                'requiredPrice' : {
                    type  : 'input',
                    style : 'rand-input',
                    id    : 'requiredPrice',
                    title : 'Requested Price',
                    value : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customervaluation.validatePage(3);
                    }
                }
            };
        },

        _listMakesModelsTypes : function( fromItemData, callback )
        {
            if (fromItemData)
            {
                var year     = _w.customervaluation.itemData.stock.vehicleYear;
                var category = _w.customervaluation.itemData.stock.type.category.id;
                var make     = _w.customervaluation.itemData.stock.type.model.make.id;
                var model    = _w.customervaluation.itemData.stock.type.model.id;
                var type     = _w.customervaluation.itemData.stock.type.id;
            }
            else
            {
                var year = $('#vehicleYear').val();
                var category = $('#vehicleCategory').val();
                var make = $('#vehicleMake').val();
                var model = $('#vehicleModel').val();
                var type = $('#vehicleType').val();
                var mmcode = $('#mmCode').val();
            }
            if (year && category)
            {
                App.DataStore.loadSelectListData(
                    'makes', false, 'Stock', 'Utility.ListMakes', null,
                    {"Filter": {
                        "category": category,
                        "year": year
                    }}, {}, $.proxy(function (categoryId)
                    {
                        if (8 == categoryId)
                        {
                            var data = App.DataStore.getData('makes');
                            data.unshift({
                                value: -1,
                                label: 'Custom'
                            });
                            App.DataStore.setData('makes', data);
                        }
                    }, this, category)
                );
            }
            if (make && year && category)
            {
                App.DataStore.loadSelectListData(
                    'models', false, 'Stock', 'Utility.ListModels', null,
                    {"Filter": {
                        "make": make,
                        "category": category,
                        "year": year
                    }}, {}, $.proxy(function (categoryId)
                    {
                        if (8 == categoryId)
                        {
                            var data = App.DataStore.getData('models');
                            data.unshift({
                                value: -1,
                                label: 'Custom'
                            });
                            App.DataStore.setData('models', data);
                        }
                    }, this, category)
                );
            }
            if (model && year && category)
            {
                App.DataStore.loadSelectListData(
                    'types', false, 'Stock', 'Utility.ListTypes', null,
                    {"Filter": {
                        "model": model,
                        "category": category,
                        "year": year
                    }}, {}, $.proxy(function (categoryId, callback)
                    {
                        if (8 == categoryId)
                        {
                            var data = App.DataStore.getData('types');
                            data.unshift({
                                value: -1,
                                label: 'Custom'
                            });
                            App.DataStore.setData('types', data);
                        }
                        if (callback)
                        {
                            callback();
                        }
                    }, this, category, callback)
                );
            }
        },

        _setupValidation : function ()
        {
            var rules = {
                firstName: {required: true, minlength: 3},
                familyName: {required: true, minlength: 3},
                email: {required: true, email: true},
                confirmEmail: {required: true, email: true, equalTo: "#email"},
                mobile: {required: true, mobile: true},
                region: {required: true},
                city: {required: false},
                publicCentre: {required: true},
                street: {required: false},
                requiredPrice: {required: false, number: true, min: 0.01},
                vehicleYear: "required",
                vehicleCategory: "required",
                vehicleMake: "required",
                vehicleModel: "required",
                vehicleType: "required",
                vehicleFuelType: "required",
                vehicleTransmissionType: "required",
                registrationNumber: "required",
                fullServiceHistory: "required",
                km: { required: true, digits: true }
            };
            $('#frmCustomerValuationView').validate({
                "rules": rules,
                messages: {
                    firstName: {
                        minlength: "This field is required."
                    },
                    familyName: {
                        minlength: "This field is required."
                    },
                    email: {
                        required: "This field is required.",
                        email: "Please enter a valid<br/>email address."
                    },
                    confirmEmail: {
                        required: "This field is required.",
                        email: "Please enter a valid<br/>email address.",
                        equalTo: "Please enter the same<br/>value again."
                    },
                    requiredPrice: {
                        required: "This field is required.",
                        number: "Please enter a valid amount.",
                        min: "Please enter a<br/>valid amount."
                    },
                    vehicleYear : "This field is required.",
                    vehicleCategory : "This field is required.",
                    vehicleMake : "This field is required.",
                    vehicleModel : "This field is required.",
                    vehicleType : "This field is required.",
                    vehicleFuelType : "This field is required.",
                    vehicleTransmissionType : "This field is required.",
                    fullServiceHistory : "This field is required.",
                    registrationNumber : "This field is required.",
                    km : {required: "This field is required."}
                },
                invalidHandler: function(event, validator) {
                    var errors = validator.numberOfInvalids();
                    if (0 < _w.customervaluation.validations && errors) {
                        var message = errors == 1
                            ? 'You missed 1 field. It has been highlighted'
                            : 'You missed ' + errors + ' fields. They have been highlighted';
                        alert(message);
                    }
                    _w.customervaluation.validations++;
                },
                submitHandler: function( form ) {
                    return;
                }
            });
            try {
                _w.customervaluation.validations = 0;
                $('#frmCustomerValuationView').valid();
            } catch(err) {}
            $('label.error').remove();
            $('.valid').removeClass('valid');
        },

        _onTuReady : function ()
        {
            App.API.execTask(
                'TransUnionFromMmCode', {
                    Filter : {
                        vehicleYear : parseInt($('#vehicleYear').val()),
                        type : parseInt($('#vehicleType').val())
                    }
                }, {},
                _w.customervaluation._onTuReceived, function(){alert('There were no trade and retail from TransUnion');}
            );
        },

        _onTuReceived : function ( response )
        {
            if ('Success' != response.Data.Status)
            {
                alert(response.Data.Status);
                return;
            }
            var vals = response.Data.VehicleDetails[0].Value;
            $('#retailPrice').val(vals.RetailPrice);
            $('#tradePrice').val(vals.TradePrice);
            $('#listPrice').val(vals.NewPrice);
            $('#' + _w.customervaluation.ti.tid + '_retailPrice').html('R ' + vals.RetailPrice + '.00');
            $('#' + _w.customervaluation.ti.tid + '_tradePrice').html('R ' + vals.TradePrice + '.00');
            $('#' + _w.customervaluation.ti.tid + '_listPrice').html('R ' + vals.NewPrice + '.00');
        },

        _prepValuationUpdateData : function()
        {
            function isValidEmailAddress(emailAddress) {
                var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
                return pattern.test(emailAddress);
            };

            var data = _w.customervaluation.ti.harvest();
            data.km = '' == data.km
                ? 0
                : parseInt(data.km);
            //data.retailPrice = 0.00;
            //data.tradePrice = 0.00;
            //data.listPrice = 0.00;
            var retailPrice = $('#retailPrice').val();
            var tradePrice = $('#tradePrice').val();
            var listPrice = $('#listPrice').val();

            data.retailPrice = ('' == retailPrice)
                ? 0.00
                : parseFloat(retailPrice);
            data.tradePrice = ('' == tradePrice)
                ? 0.00
                : parseFloat(tradePrice);
            data.listPrice = ('' == listPrice)
                ? 0.00
                : parseFloat(listPrice);

            delete data.damageTotal;


            var postData = {Stock:{}, Valuation:{}};
            var valuationFields = [
                "firstName","familyName","mobile",
                "email","region","city","street","requiredPrice"," publicCentre"
            ];
            for (var field in data)
            {
                if (-1 == valuationFields.indexOf(field))
                {
                    postData.Stock[field] = data[field];
                }
                else
                {
                    postData.Valuation[field] = data[field];
                }
            }


            if('' == postData.Valuation.requiredPrice)
            {
                postData.Valuation.requiredPrice = 0;
            }

            if( !isValidEmailAddress( postData.Valuation.email ) )
            {
                testEmail = postData.Valuation.email;
                console.log("went through check", testEmail);
                postData.Valuation.email = null;
            }


            if ('' == postData.Valuation.email)
            {
                postData.Valuation.email = null;
            }

            return postData;
        },

        _onValuationUpdated : function( response )
        {
            //alert('Your vehicle has successfully been submitted.');
            window.location.hash = '/thankyouvaluation';

            //send customer valuation email
        },
        _onValuationFail : function( response )
        {
            console.log('response',response );
            alert('Oops, something went wrong, please check your data carefully and try again.');
            //window.location.hash = '/public-landing';
        }



    };

    //this is for refreshing dropdowns if no data is populated on first load
//    setTimeout(
//        $.proxy(function(){
////						console.log('PageContent', $('#PageContent').children().length);
////            if ( $('#vehicleYear').children().length == 0 ) {
////                console.log ('PageContent no Year data - running task again...');
////                _w.customervaluation.setValuationViewFormMeta();
////            }
////
////            if ( $('#vehicleCategory').children().length == 0 ) {
////                _w.customervaluation.setValuationViewFormMeta();
////            }
////
////
//            if ( $('#publicCenter').children().length == 0 ) {
//                console.log ('PageContent no publicCenter data - running task again...');
//                _w.customervaluation.setValuationViewFormMeta();
//            }
//
//            if ( $('#vehicleYear').children().length == 0 ) {
//                App.DataStore.loadSelectListData(
//                    'years', false, 'Stock', 'Year.SelectList', null,
//                    {}
//                );
//            }
//            if ( $('#vehicleCategory').children().length == 0 ) {
//                App.DataStore.loadSelectListData(
//                    'categories', false, 'Stock', 'Category.SelectList', null,
//                    {}
//                );
//            }
//            if ( $('#fullServiceHistory').children().length == 0 ) {
//                App.DataStore.loadSelectListData(
//                    'fsh', false, 'Stock', 'FullServiceHistory.SelectList', null,
//                    {}
//                );
//            }
//            if ( $('#vehicleFuelType').children().length == 0 ) {
//                App.DataStore.loadSelectListData(
//                    'fuelTypes', false, 'Stock', 'FuelType.SelectList', null,
//                    {}
//                );
//            }
//            if ( $('#vehicleTransmissionType').children().length == 0 ) {
//                App.DataStore.loadSelectListData(
//                    'transmissionTypes', false, 'Stock', 'TransmissionType.SelectList', null,
//                    {}
//                );
//            }
//        }, this), 5000
//    );

    //setTimeout(
    //    $.proxy(function(){
    //        if ( $('#vehicleYear').children().length == 0 ) {
    //            location.reload();
    //            console.log('reload');
    //            alert('reload');
    //        }
    //    }, this), 10000
    //);
})();