;(function(){

	window._w.membershipview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		limited : false,
		newItem : false,
		ownAccount : true,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.membershipview.ti = _t[template];
			_w.membershipview.limited = ('limitedmembershipview' == template)
				? true
				: false;

			App.DataStore.loadSelectListData('years', true, 'Stock', 'Year.SelectList');
			App.DataStore.loadSelectListData('makes', true, 'Stock', 'Make.SelectList');

			_w.membershipview.setMembershipViewFormMeta();
			_w.membershipview.ti.hydrate(_w.membershipview.formMeta);

			// Retrieve initial view data.
			_w.membershipview.itemId = App.Util.getUrlParam('id');
			_w.membershipview.newItem = false;
			App.API.getTask(
				'updateMembership:' + _w.membershipview.itemId, 'PriceGuide', 'Member.Update', null,
				{'id':_w.membershipview.itemId},
				$.proxy( _w.membershipview._onMembershipViewDataReceived, this ),
				_w.taskContractError
			);

		},

		onViewPublished : function( template, event, eventData )
		{
			if (null != _w.membershipview.itemData)
			{
				_w.membershipview._onDataAndTemplate();
			}
		},

		setMembershipViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.membershipview.formMeta = {
				'fromKm' : {
					type  : 'input',
					id    : 'fromKm',
					title : 'Minimum km',
					value : data.fromKm ? data.fromKm : ''
				},
				'toKm' : {
					type  : 'input',
					id    : 'toKm',
					title : 'Maximum km',
					value : data.toKm ? data.toKm : ''
				},
				'fromYear' : {
					type  : 'select',
					id    : 'fromYear',
					title : 'From year',
					dataStoreId : 'years',
					value : data.fromYear ? data.fromYear : ''
				},
				'toYear' : {
					type  : 'select',
					id    : 'toYear',
					title : 'To year',
					dataStoreId : 'years',
					value : data.toYear ? data.toYear : ''
				},
				'emailNotification' : {
					type  : 'checkbox',
					id    : 'emailNotification',
					title : 'Receive email notifications',
					value : data.emailNotification
				},
				'smsNotification' : {
					type  : 'checkbox',
					id    : 'smsNotification',
					title : 'Receive sms notifications',
					value : data.smsNotification
				},
				'allMakes' : {
					type  : 'checkbox',
					id    : 'allMakes',
					title : 'All makes',
					value : data.allMakes ? data.allMakes : false,
					onChange : function() {
						$(this).prop('checked')
							? $('#makes-section').hide()
							: $('#makes-section').show();
					}
				},
				'applyToAll' : {
					type  : 'checkbox',
					id    : 'applyToAll',
					title : 'Apply changes to all clubs',
					value : false
				},
				'makes' : {
					type        : 'checkGroup',
					id          : 'makes',
					dataStoreId : 'makes',
					itemName    : 'makes',
					split       : 4,
					data        : data.makes ? data.makes : {}
				}
			};
		},

		_onDataAndTemplate : function ()
		{
			if (!_w.membershipview.itemData.allMakes)
			{
				$('#makes-section').show();
			}
			if ('Invited' == _w.membershipview.itemData.status)
			{
				$('#btnUpdate').hide();
				$('#btnAccept').show();
				$('#btnDecline').show();
				$('#btnAccept').click(function() {
					App.API.getTask(
							'acceptMembership:' + _w.membershipview.itemId, 'PriceGuide', 'Member.Accept', null,
							{'id':_w.membershipview.itemId}, function() {
								App.API.execTask(
										'acceptMembership:' + _w.membershipview.itemId, {}, {},
										_w.membershipview._onMembershipUpdated, _w.taskExecError
									);
							}, _w.taskContractError
						);
				});
				$('#btnDecline').click(function() {
					App.API.getTask(
							'declineMembership:' + _w.membershipview.itemId, 'PriceGuide', 'Member.Decline', null,
							{'id':_w.membershipview.itemId}, function() {
								App.API.execTask(
										'declineMembership:' + _w.membershipview.itemId, {}, {},
										_w.membershipview._onMembershipUpdated, _w.taskExecError
									);
							}, _w.taskContractError
						);
				});
			}
			if ('Active' != _w.membershipview.itemData.status)
			{
				$('#btnUpdate').hide();
			}
			if ('Active' == _w.membershipview.itemData.status)
			{
				$('#btnDeactivate').show();
				$('#btnDeactivate').click(function() {
					App.API.getTask(
							'deactivateMembership:' + _w.membershipview.itemId, 'PriceGuide', 'Member.Deactivate', null,
							{'id':_w.membershipview.itemId}, function() {
								App.API.execTask(
										'deactivateMembership:' + _w.membershipview.itemId, {}, {},
										_w.membershipview._onMembershipUpdated, _w.taskExecError
									);
							}, _w.taskContractError
						);
				});
			}
			if ('Inactive' == _w.membershipview.itemData.status || 'Declined' == _w.membershipview.itemData.status)
			{
				$('#btnActivate').show();
				$('#btnActivate').click(function() {
					App.API.getTask(
							'activateMembership:' + _w.membershipview.itemId, 'PriceGuide', 'Member.Activate', null,
							{'id':_w.membershipview.itemId}, function() {
								App.API.execTask(
										'activateMembership:' + _w.membershipview.itemId, {}, {},
										_w.membershipview._onMembershipUpdated, _w.taskExecError
									);
							}, _w.taskContractError
						);
				});
			}
			_w.membershipview._setupValidation();
		},

		_onMembershipViewDataReceived : function( response )
		{
			_w.membershipview.itemId = response.Data.id;
			_w.membershipview.itemData = response.Data;
			_w.membershipview.setMembershipViewFormMeta(response.Data);
			_w.membershipview.ti.hydrate(_w.membershipview.formMeta);
			if (_w.membershipview.ti.published)
			{
				_w.membershipview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			$('#frmMembershipView').validate({
				"rules": {
					fromKm: {digits: true},
					toKm: {digits: true}
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.membershipview._prepMembershipUpdateData();
					App.API.execTask(
							'updateMembership:' + _w.membershipview.itemId, data, {},
							_w.membershipview._onMembershipUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepMembershipUpdateData : function()
		{
			var data = _w.membershipview.ti.harvest();
			if ('' == data.fromKm)
			{
				data.fromKm = null;
			}
			if ('' == data.toKm)
			{
				data.toKm = null;
			}
			return {Member:data};
		},

		_onMembershipUpdated : function( response )
		{
			window.location.hash = '/settings';
		}

	};

})();