;(function(){

	window._w.memberview = {

		clubId : null,
		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		newItem : false,
		ownAccount : true,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.memberview.ti = _t[template];

			_w.memberview.setMemberViewFormMeta();
			_w.memberview.ti.hydrate(_w.memberview.formMeta);

			// Retrieve initial view data.
			_w.memberview.itemId = App.Util.getUrlParam('id');
			_w.memberview.clubId = App.Util.getUrlParam('clubId');
			_w.memberview.newItem = false;
			App.API.getTask(
				'updateClubMember:' + _w.memberview.itemId, 'PriceGuide', 'Member.UpdateStatus', null,
				{'id':_w.memberview.itemId},
				$.proxy( _w.memberview._onMemberViewDataReceived, this ),
				_w.taskContractError
			);
		},

		onViewPublished : function( template, event, eventData )
		{
			if (null != _w.memberview.itemData)
			{
				_w.memberview._onDataAndTemplate();
			}
		},

		setMemberViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.memberview.formMeta = {
				'companyName' : {
					title : 'Dealer',
					value : data.company ? data.company.name : ''
				},
				'firstName' : {
					title : 'Name',
					value : data.profile ? data.profile.firstName : ''
				},
				'familyName' : {
					title : 'Surname',
					value : data.profile ? data.profile.familyName : ''
				},
				'email' : {
					title : 'Email',
					value : data.profile ? data.profile.email : ''
				}
			};
		},

		_onDataAndTemplate : function ()
		{
			if ('Active' == _w.memberview.itemData.status)
			{
				$('#btnSuspend').show();
				$('#btnSuspend').click(function() {
					App.API.execTask(
							'updateClubMember:' + _w.memberview.itemId, {Member:{status:'Suspended'}}, {},
							_w.memberview._onMemberUpdated, _w.taskExecError
						);
				});
			}
			if ('Suspended' == _w.memberview.itemData.status)
			{
				$('#btnActivate').show();
				$('#btnActivate').click(function() {
					App.API.execTask(
							'updateClubMember:' + _w.memberview.itemId, {Member:{status:'Active'}}, {},
							_w.memberview._onMemberUpdated, _w.taskExecError
						);
				});
				$('#btnArchive').show();
				$('#btnArchive').click(function() {
					App.API.execTask(
							'updateClubMember:' + _w.memberview.itemId, {Member:{status:'Archived'}}, {},
							_w.memberview._onMemberUpdated, _w.taskExecError
						);
				});
			}
			if ('Archived' == _w.memberview.itemData.status)
			{
				$('#btnUnarchive').show();
				$('#btnUnarchive').click(function() {
					App.API.execTask(
							'updateClubMember:' + _w.memberview.itemId, {Member:{status:'Active'}}, {},
							_w.memberview._onMemberUpdated, _w.taskExecError
						);
				});
			}
		},

		_onMemberViewDataReceived : function( response )
		{
			_w.memberview.itemId = response.Data.id;
			_w.memberview.itemData = response.Data;
			_w.memberview.setMemberViewFormMeta(response.Data);
			_w.memberview.ti.hydrate(_w.memberview.formMeta);
			if (_w.memberview.ti.published)
			{
				_w.memberview._onDataAndTemplate();
			}
		},

		_onMemberUpdated : function( response )
		{
			window.location.hash = '/clubview?id=' + _w.memberview.clubId;
		}

	};

})();