;(function(){

	window._w.priceguide = {

		ti : null,
		dfrom : '',
		dto   : '',
		gridStatus : null,

		onPageDestruct : function()
		{
			App.Event.removeListener('priceguideGridSuFilter', 'SuChange');
		},

		onPriceGuidePageTemplateReady : function( template, event, eventData )
		{
			App.DataStore.loadSelectListData('filtermakes', true, 'Stock', 'Make.SelectList');
			App.DataStore.loadSelectListData('regions', true, 'Location', 'Region.SelectList');
			_w.priceguide.ti = _t[template];
			App.DataStore.setData('pgstatuses',
					[
					 {"value":"Updateable Offer", "label":"Updateable Offer"},
					 {"value":"Valid Offer", "label":"Valid Offer"},
					 {"value":"Offer Accepted", "label":"Offer Accepted"},
					 {"value":"Expired", "label":"Expired"},
					 {"value":"Archived", "label":"Archived"}
					 ]
			);
			_w.priceguide.ti.hydrate({
				'gridTitle': 'Price Guide',
				'gridTitleSubtext': 'Please use the filters below to narrow down the view',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'GridExport',
							id: 'exportPriceGuideGrid',
							handler: _w.priceguide.exportPriceGuideGrid
						}
					}
				},
				'gridContextFilter': {
					constructor: 'GridContextFilter',
					items: {
						RefNum: {
							title: 'Search here:',
							style: 'filter-input-wrapper hidden-tablet hidden-phone',
							id: 'gridPriceGuideContext_RefNo',
							placeholder: 'Ref number',
							context: 'gridPriceGuideContext'
						},
						RegNum: {
							style: 'filter-input-wrapper hidden-tablet hidden-phone',
							id: 'gridPriceGuideContext_RegNo',
							placeholder: 'Registration number',
							context: 'gridPriceGuideContext'
						},
						DateFrom: {
							style : 'input-append date filter-input-wrapper-date mobile-width12p dfrom hidden-tablet hidden-phone',
							title: 'Search date created here',
							id: 'gridPriceGuideContext_DateFrom',
							placeholder: 'From',
							context: 'gridPriceGuideContext',
							append: '<i class="icon-calendar"></i>',
							readonly: true,
							bind: function() {
								$('#gridPriceGuideContext_DateFrom').change(function() {
									_w.priceguide.dFrom = $(this).val();
								});
							}
						},
						DateTo: {
							style : 'input-append date filter-input-wrapper-date mobile-width12p dto hidden-tablet hidden-phone',
							id: 'gridPriceGuideContext_DateTo',
							placeholder: 'To',
							context: 'gridPriceGuideContext',
							append: '<i class="icon-calendar"></i>',
							readonly: true,
							bind: function() {
								$('#gridPriceGuideContext_DateTo').change(function() {
									_w.priceguide.dTo = $(this).val();
								});
							}
						},
						RegNumMobi: {
							style: 'filter-input-wrapper hidden-desktop',
							id: 'gridPriceGuideContext_RegNoMobi',
							placeholder: 'Registration number',
							context: 'gridPriceGuideContext'
						},
						
						MakeMobi: {
							style: 'filter-input-wrapper filter-input-select',
							placeholder: 'Make Mobi',
							id: 'gridPriceGuideContext_MakeMobi',
							context: 'gridPriceGuideContext',
							dataStoreId : 'filtermakes',
							selectEmpty : 'All Makes',
							style: 'MakeMobi hidden-desktop ',
							bind : function(meta){
								$('#gridAuctionFilter_MakeMobi').change(function(){
									$('#gridAuctionFilter_Make').selectpicker('val', $(this).val());
								});
							}
						},
						RegionMobi: {
							style: 'filter-input-wrapper filter-input-select ',
							placeholder: 'Region Mobi',
							id: 'gridPriceGuideContext_RegionMobi',
							context: 'gridPriceGuideContext',
							dataStoreId : 'regions',
							selectEmpty : 'Regions',
							style: 'RegionMobi hidden-desktop ',
							bind : function(meta){
								$('#gridAuctionFilter_RegionMobi').change(function(){
									$('#gridAuctionFilter_Region').selectpicker('val', $(this).val());
								});
							}
						},
						
						Buttons: {
							actions			:true,
							searchId		:'btnSearch',
							bindSearch		:_w.priceguide.searchPriceGuideGrid,
							clearId			:'btnClearSearch',
							bindClear		:_w.priceguide.clearPriceGuideGridContext

						}
					}
				},

				'gridColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Make: {
							id: 'gridPriceGuideColumn_Make',
							title: 'MAKE',
							orderAsc: {
								id: 'gridPriceGuideOrder_MakeAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_MakeDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'make.name', 'DESC')
							},
							style: ' hidden-phone'
						},
						Type: {
							id: 'gridPriceGuideColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridPriceGuideOrder_TypeAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_TypeDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'type.name', 'DESC')
							},
							style: 'type'
						},
						Year: {
							id: 'gridPriceGuideColumn_Year',
							title: 'YEAR',
							orderAsc: {
								id: 'gridPriceGuideOrder_YearAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'vehicleYear.name', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_YearDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'vehicleYear.name', 'DESC')
							},
							style: 'year'
						},
						KM: {
							id: 'gridPriceGuideColumn_KM',
							title: 'KM&#39;S',
							orderAsc: {
								id: 'gridPriceGuideOrder_KMAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.km', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_KMDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.km', 'DESC')
							},
							style: 'kms hidden-phone'
						},
						Trade: {
							id: 'gridPriceGuideColumn_Trade',
							title: 'TRADE',
							orderAsc: {
								id: 'gridPriceGuideOrder_TradeAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.tradePrice', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_TradeDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.tradePrice', 'DESC')
							},
							style: 'hidden-phone'
						},
                        List: {
                            id: 'gridPriceGuideColumn_List',
                            title: 'NEW LIST PRICE',
                            orderAsc: {
                                id: 'gridPriceGuideOrder_ListAsc',
                                bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.listPrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridPriceGuideOrder_ListDesc',
                                bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.listPrice', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
						Company: {
							id: 'gridPriceGuideColumn_Retail',
							title: 'DEALERSHIP',
							orderAsc: {
								id: 'gridPriceGuideOrder_CompanyAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_CompanyDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'company.name', 'DESC')
							},
							style: 'hidden-phone'
						},
						Region: {
							id: 'gridPriceGuideColumn_Retail',
							title: 'REGION',
							orderAsc: {
								id: 'gridPriceGuideOrder_RegionAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'region.name', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_RegionDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'region.name', 'DESC')
							},
							style: 'hidden-phone'
						},
						CustomerRequest: {
							id: 'gridPriceGuideColumn_Request',
							title: 'CUSTOMER REQUEST',
							orderAsc: {
								id: 'gridPriceGuideOrder_RequestAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'valuation.requiredPrice', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_RequestDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'valuation.requiredPrice', 'DESC')
							},
							style: 'hidden-phone'
						},
						Offer: {
							id: 'gridPriceGuideColumn_Offer',
							title: 'MY OFFER',
							orderAsc: {
								id: 'gridPriceGuideOrder_OfferAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'offer.amount', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_OfferDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'offer.amount', 'DESC')
							},
							style: 'offer-submitted'
						},
						HighestOffer: {
							id: 'gridPriceGuideColumn_HighestOffer',
							title: 'HIGHEST OFFER',
							orderAsc: {
								id: 'gridPriceGuideOrder_HighestOfferAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.highestOffer', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_HighestOfferDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'stock.highestOffer', 'DESC')
							},
							style: 'offer-submitted hidden-phone'
						},
						Time: {
							id: 'gridPriceGuideColumn_Time',
							title: 'TIME LEFT',
							style: 'Time '
						},
						
						Status: {
							id: 'gridPriceGuideColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridPriceGuideOrder_StatusAsc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'offer.status', 'ASC')
							},
							orderDesc: {
								id: 'gridPriceGuideOrder_StatusDesc',
								bind: $.proxy(_w.priceguide.orderPriceGuideGrid, this, 'offer.status', 'DESC')
							},
							style: ' hidden-phone'

						},
					}
				},
				'gridColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Make: {
							id: 'gridPriceGuideFilter_Make',
							context: 'gridPriceGuideFilter',
							dataStoreId : 'filtermakes',
							selectEmpty : 'All',
							bind : function(meta){
								_w.priceguide.changes = 0;
								$('#' + meta.id).change(function(){
									_w.priceguide.changes++;
									if (1 == _w.priceguide.changes || 'Active' != _w.priceguide.gridStatus)
									{
										return;
									}
									_w.priceguide.searchPriceGuideGrid();
								});
							}
						},
						Type: {
							id: 'gridPriceGuideFilter_Type',
							context: 'gridPriceGuideFilter'
						},
						Year: {
							id: 'gridPriceGuideFilter_Year',
							context: 'gridPriceGuideFilter'
						},
						KM: {
							id: 'gridPriceGuideFilter_KM',
							context: 'gridPriceGuideFilter'
						},
						Trade: {
							id: 'gridPriceGuideFilter_Trade',
							context: 'gridPriceGuideFilter'
						},

						Company: {
							id: 'gridPriceGuideFilter_Company',
							context: 'gridPriceGuideFilter'
						},
						Region: {
							id: 'gridPriceGuideFilter_Region',
							context: 'gridPriceGuideFilter',
							dataStoreId : 'regions',
							selectEmpty : 'All',
							bind : function(meta){
								_w.priceguide.changes = 0;
								$('#' + meta.id).change(function(){
									_w.priceguide.changes++;
									if (1 == _w.priceguide.changes || 'Active' != _w.priceguide.gridStatus)
									{
										return;
									}
									_w.priceguide.searchPriceGuideGrid();
								});
							}
						},

						CustomerRequest: {
							id: 'gridPriceGuideFilter_Request',
							context: 'gridPriceGuideFilter'
						},
						Offer: {
							id: 'gridPriceGuideFilter_Offer',
							context: 'gridPriceGuideFilter'
						},
						HighestOffer: {
							id: 'gridPriceGuideFilter_HighestOffer',
							context: 'gridPriceGuideFilter'
						},
						Time: {},
						Status: {
							id: 'gridPriceGuideFilter_Status',
							context: 'gridPriceGuideFilter',
							dataStoreId : 'pgstatuses',
							selectEmpty : 'All',
							bind : function(meta){
								_w.priceguide.changes = 0;
								$('#' + meta.id).change(function(){
									_w.priceguide.changes++;
									if (1 == _w.priceguide.changes || 'Active' != _w.priceguide.gridStatus)
									{
										return;
									}
									_w.priceguide.searchPriceGuideGrid();
								});
							}
						},
					}
				},
				'gridRowRepeater': {},
				'gridPager': {}
			});

			// Retrieve initial grid data.
			if (null == App.API.taskContract('gridPriceGuide'))
			{
				App.API.getTask(
						'gridPriceGuide', 'PriceGuide', 'PriceGuide.Grid', null,
						{}, _w.priceguide.loadPriceGuideGrid, _w.taskContractError
						);
			}
			else
			{
				_w.priceguide.loadPriceGuideGrid( null, {}, {} );
			}
		},

		onPriceGuideGridPublished : function()
		{
			
			//mobi menu
			
			var isMobile = 'none' == $('#mobiCheck').css('display');
			
			console.log("isMobile", isMobile);
			
			
			//var isMobile = 'none' == $('.header').css('display');
			if (isMobile)
			{
				// show the mobi menu && hide old menu 
				$("#MobiAuctionPriceGuideMenu").show();
				$("#MobiPortalMenu").hide();
				 
				// Check active state
				$("#mobiAuctionBtn").removeClass("active");
				$("#mobiPriceGuideBtn").addClass("active");
				$("#mobiValuationsBtn").removeClass("active");
			}
			
			$("#mobiAuctionBtn").click(function() {
				window.location.hash = '#/auction';
			});
			
			$("#mobiValuationsBtn").click(function() {
				window.location.hash = '#/valuations';
			});
			
			
			$(".gridPriceGuideFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnSearch').click();
				}
			});
			$(".gridPriceGuideContext").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnSearch').click();
				}
			});


			$('#exportPriceGuideGrid').prop('disabled', !App.permissions.pgGridExport);

			var setTableFormWidth = function()
				{
					$('.table-form').css({
						width : $(window).width() * 0.96
					});
				};

			$(window).on('resize', setTableFormWidth );
			setTableFormWidth();

			App.Event.listen('priceguideGridSuFilter', 'SuChange', $.proxy(_w.priceguide.loadPriceGuideGrid, this), 'Recurring');

			setTimeout(_w.priceguide.refreshGrid, 120000);
			$('.dfrom').datepicker({format:"yyyy-mm-dd"});
			$('.dto').datepicker({format:"yyyy-mm-dd"});
			$('#gridPriceGuideContext_DateFrom').val(_w.priceguide.dFrom);
			$('#gridPriceGuideContext_DateTo').val(_w.priceguide.dTo);
		},

		refreshGrid : function()
		{
			if ('priceguide' != App.activePage)
			{
				return;
			}
			_w.priceguide.loadPriceGuideGrid( null, {}, {} );
			setTimeout(_w.priceguide.refreshGrid, 120000);
		},

		pagePriceGuideGrid : function( page )
		{
			_w.priceguide.loadPriceGuideGrid( {}, {"Grid":{"Page":page}} );
		},

		loadPriceGuideGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridPriceGuide', data, options,
					_w.priceguide._onPriceGuideGridDataReceived, _w.taskExecError
					);
		},

		_onPriceGuideGridDataReceived : function( response )
		{
			_w.priceguide.gridStatus = 'Active';
			_w.priceguide.ti.hydrateParam('gridRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'stock.registrationNumber': 'gridPriceGuideContext_RegNo',
				'stock.referenceNumber': 'gridPriceGuideContext_RefNo',
				'make.id': 'gridPriceGuideFilter_Make',
				'type.name': 'gridPriceGuideFilter_Type',
				'vehicleYear.name': 'gridPriceGuideFilter_Year',
				'stock.km': 'gridPriceGuideFilter_KM',
				'stock.tradePrice': 'gridPriceGuideFilter_Trade',
                'stock.listPrice': 'gridPriceGuideFilter_List',
				'company.name': 'gridPriceGuideFilter_Company',
				'region.id': 'gridPriceGuideFilter_Region',
				'valuation.requiredPrice': 'gridPriceGuideFilter_Request',
				'offer.amount': 'gridPriceGuideFilter_Offer',
				'stock.highestOffer': 'gridPriceGuideFilter_HighestOffer',
				'offer.status': 'gridPriceGuideFilter_Status'
			});
			$('select.gridPriceGuideFilter').each(function(i, elem) {
				$(elem).selectpicker('refresh');
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				var myOffer = false;
				if (row.offers[0])
				{
					for (var z in row.offers[0])
					{
						if (row.offers[0][z].company.id == App.companyData.id)
						{
							myOffer = row.offers[0][z];
						}
					}
				}
				if ('Open4Offers' != row.jobState && 'Updateable Offers' != row.jobState)
				{
					var numDays = App.serverConfig.priceGuideCompletionDays;
					var hoursLeft = App.Util.calculateTimeLeft(row.created, numDays);
				}
				else
				{
					var numHours = App.serverConfig.priceGuideOpenDays;
					var hoursLeft = App.Util.calculateTimeLeftHours(row.created, numHours);
				}

				gridData.push({
					lineClass: 'handy',
					surl: myOffer
						? 'offerview'
						: 'offerview',
					prepend: {
						Trade  : 'R ',
						CustomerRequest  : 'R ',
						Offer  : 'R ',
						HighestOffer  : 'R '
					},
					rowId: row.id,
					myOffer: myOffer,
					jobState: row.jobState,
					bind: function(meta) {
						$('#row' +  meta.rowId).click(function(e){
							window.location='#/' + meta.surl + '?pgId=' + meta.rowId + '&id=' + (meta.myOffer ? meta.myOffer.id : 0);
						});
						if ('Open4Offers' == meta.jobState || 'Updateable Offers' == meta.jobState)
						{
							$('#ofr' + meta.rowId).click(function(e) {
								_w.PopUp = true;
								e.preventDefault();
								e.stopPropagation();
							});
						}
						else
						{
							$('#ofr' + meta.rowId).click(function(e) {
								_w.PopUp = true;
								e.preventDefault();
								e.stopPropagation();
								$('#modalbody').html('<center>Loading offers...</center>');
								$('#myModal').modal('toggle');
								App.API.getTask(
										'offerList', 'PriceGuide', 'Offer.List',
										meta.rowId, {}, function(){
											App.API.execTask(
												'offerList', {}, {},
												function(response)
												{
													console.log("meta.rowId", meta.rowId);
													var offers = response.Data;
													if (offers.length)
													{
														var modalbody = '<table class="table table-bordered table-condensed table-striped">';
														modalbody += '<tr><td>Date Offered</td><td>Amount</td></tr>';
														for (var x in offers)
														{
															var isOwn = offers[x].company.id == App.companyData.id
																? true
																: false;
															modalbody +=
																'<tr class="modalrow ' + (isOwn ? 'red' : 'black') + '">'
																+ '<td class="date">' + offers[x].created + '</td>'
																+ '<td class="wide">R' + offers[x].amount + '</td>'
																+ '</tr>';
														}
						 								modalbody += '</table>';
													}
													else
													{
														var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no offers!</div>';
													}
													$('#modalbody').html(modalbody);
												}, _w.taskExecError
											);
										}, _w.taskContractError
								);
							});
						}

					},
					style: {

						Make  		: 'make hidden-phone',
						Type  		: 'type',
						Year  		: 'year',
						KM  		: 'hidden-phone',
						Trade  		: 'hidden-phone',
						Company  	: 'hidden-phone',
						Region  	: 'hidden-phone',
						CustomerRequest: 'hidden-phone',
						Offer  		: 'offer',
						HighestOffer: 'offer hidden-phone',
						Time  		: 'Time ',
						Status  	: 'status hidden-phone'
					},
					items: {
						'id'      : {'pgId' : row.id, 'id' : myOffer ? myOffer.id : 0},
						'Make'    : row.stock.type.model.make.name,
						'Type'    : row.stock.type.name,
						'Year'    : row.stock.vehicleYear.name,
						'KM'      : row.stock.km,
						'Trade'   : row.stock.tradePrice,
                        'List'   : row.stock.listPrice,
						'Company' : row.company.name,
						'Region'  : row.company.region.name,
						'CustomerRequest': row.stock.valuation && row.stock.valuation.requiredPrice
								? row.stock.valuation.requiredPrice
								: 0.00,
						'Offer'   : myOffer
								? myOffer.amount + '<a class="soda_pop hidden-phone hidden-tablet" id="ofr' + row.id + '"><span>' + row.stock.numberOfOffers + '</span></a>'
								: '<a class="soda_pop hidden-phone hidden-tablet" id="ofr' + row.id + '"><span>' + row.stock.numberOfOffers + '</span></a>',
						'HighestOffer' : ('Open4Offers' != row.jobState && 'Updateable Offers' != row.jobState)
											&& row.stock.highestOffer
								? row.stock.highestOffer
								: '',
						'Time'    : hoursLeft,
						'Status'  : myOffer
								? myOffer.status
								: ('Open4Offers' == row.jobState || 'Updateable Offers' == row.jobState ? '* Open4Offers' : '* Expired')
				}
				});
			}
			_w.PopUp = false;
			_w.priceguide.ti.hydrateParam('gridRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'stockPager';
			response.Data.Meta.bind = _w.priceguide.pagePriceGuideGrid;
			_w.priceguide.ti.hydrateParam('gridPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			// todo: add pager hydration


			/*
			 * Permissions
			 */


		},

		exportPriceGuideGrid : function()
		{
			App.API.execTask(
					'gridPriceGuide', {}, {'ExportToExcel': true},
					_w.priceguide._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
						win.document.write(response);
		},

		clearPriceGuideGridContext : function()
		{
			_w.priceguide.gridStatus = 'Inactive';
			try
			{
				$('select.gridPriceGuideFilter').each(function(i, elem) {
					$(elem).selectpicker('val', '');
					$(elem).selectpicker('refresh');
				});
			}
			catch (err) { console.log(err); }
			$('.gridPriceGuideContext').val('');
			$('.gridPriceGuideFilter').val('');
			_w.priceguide.searchPriceGuideGrid(true);
		},

		searchPriceGuideGrid : function(resetOrder)
		{
			_w.priceguide.gridStatus = 'Inactive';
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideContext_RegNo', 'stock.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideContext_RefNo', 'stock.referenceNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideContext_DateFrom', 'priceGuide.created', '>=');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideContext_DateTo', 'priceGuide.created', '<=', ' 23:59:59');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Make', 'make.id');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Year', 'vehicleYear.name');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_KM', 'stock.km');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Trade', 'stock.tradePrice');
            filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_List', 'stock.listPrice');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Company', 'company.name');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Region', 'region.id');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Request', 'valuation.requiredPrice');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Offer', 'offer.amount');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_HighestOffer', 'stock.highestOffer');
			filter = _w.filterIfnotEmpty(filter, 'gridPriceGuideFilter_Status', 'offer.status');
			var request = {"Grid":{
					"Page": 1,
					"Filter": filter.filters
				}};
			if (resetOrder)
			{
				request.Grid.OrderBy = {'priceGuide.created': 'DESC'};
			}
			_w.priceguide.loadPriceGuideGrid( null, request, {} );
		},

		orderPriceGuideGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.priceguide.loadPriceGuideGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();