;(function(){

	window._w.replyview = {

		auctionId : null,
		itemId    : null,
		itemData  : null,
		formMeta  : null,
		ti        : null,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.replyview.ti = _t[template];
			_w.replyview.itemData = null;

			_w.replyview.setReplyViewFormMeta();
			_w.replyview.ti.hydrate(_w.replyview.formMeta);

			// Retrieve initial view data.
			_w.replyview.itemId    = App.Util.getUrlParam('id');
			_w.replyview.auctionId = App.Util.getUrlParam('auctionId');
			App.API.getTask(
				'viewQuestion:' + _w.replyview.itemId, 'Auction', 'Question.View', _w.replyview.auctionId,
				{'id':_w.replyview.itemId}, _w.replyview._onReplyViewDataReceived, _w.taskContractError
			);
			App.API.getTask(
				'createReply:' + _w.replyview.itemId, 'Auction', 'Reply.Create', _w.replyview.auctionId,
				{}, function() {}, _w.taskContractError
			);
		},

		onViewPublished : function( template, event, eventData )
		{
			if (null != _w.replyview.itemData)
			{
				_w.replyview._onDataAndTemplate();
			}
		},

		setReplyViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.replyview.formMeta = {
				'vehicle' : {
					title : 'Vehicle',
					value : data.auction
						? data.auction.stock.type.model.make.name
							+ ', ' + data.auction.stock.type.model.name
							+ ', ' + data.auction.stock.type.name
							+ ' (' + data.auction.stock.vehicleYear.name + ')'
						: ''
				},
				'created' : {
					title : 'Created',
					value : data.created ? ((data.created).split(' '))[0] : ''
				},
				'company' : {
					title : 'Company',
					value : data.company ? data.company.name : ''
				},
				'user' : {
					title : 'User',
					value : data.profile ? data.profile.firstName + ' ' + data.profile.familyName : ''
				},
				'question' : {
					title : 'Question',
					value : data.question ? data.question : ''
				},
				'reply' : {
					type  : 'textarea-styled',
					disabled : data.reply && data.reply.id ? true : false,
					id    : 'reply',
					title : 'Reply',
					style : 'span12',
					areaStyle : 'span12',
					value : data.reply ? data.reply.reply : ''
				}
			};
		},

		_onDataAndTemplate : function() {
			_w.replyview._setupValidation();
		},

		_onReplyViewDataReceived : function( response )
		{
			_w.replyview.itemId = response.Data.id;
			_w.replyview.itemData = response.Data;
			_w.replyview.setReplyViewFormMeta(response.Data);
			_w.replyview.ti.hydrate(_w.replyview.formMeta);
			if (_w.replyview.ti.published)
			{
				_w.replyview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			$('#frmReplyView').validate({
				submitHandler: function( form ) {
					if ('' == $('#reply').val())
					{
						alert('Please specify a reply.');
						return;
					}
					$('#btnUpdate').prop('disabled', true);
					var data = _w.replyview._prepReplyUpdateData();
					App.API.execTask(
							'createReply:' + _w.replyview.itemId, data, {},
							_w.replyview._onReplyUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
			if (!_w.replyview.itemData.reply || !_w.replyview.itemData.reply.id)
			{
				$('#btnUpdate').show();
			}
		},

		_prepReplyUpdateData : function()
		{
			var data = {
					Reply : {
						question : _w.replyview.itemId,
						reply    : $('#reply').val()
					}
			};
			return data;
		},

		_onReplyUpdated : function( response )
		{
			window.location.hash = '/settings';
		}

	};

})();