;(function(){

	window._w.tcstock = {

		ti : null,
		dfrom : '',
		dto   : '',

		onPageDestruct : function()
		{
			App.Event.removeListener('stockGridSuFilter', 'SuChange');
		},

		onStockPageTemplateReady : function( template, event, eventData )
		{
			_w.tcstock.ti = _t[template];
			App.DataStore.setData('stockstatuses',
					[
					 {"value":"Auction", "label":"Auction"},
					 {"value":"Trade Center", "label":"Trade Center"},
					 {"value":"Sold", "label":"Sold"},
					 {"value":"Relist", "label":"Relist"}
					 ]
			);
			App.DataStore.loadSelectListData('tcdealers', true, 'Company', 'Company.TcDealerSelectList');
			_w.tcstock.ti.hydrate({
				'gridTitle': 'Trade Stock Control',
				'gridTitleSubtext': 'Please use the filters below to narrow down the view',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'GridExport',
							id: 'exportStockGrid',
							handler: _w.tcstock.exportStockGrid
						}
					}
				},
				'gridContextFilter': {
					constructor: 'GridContextFilter',
					items: {
						RegNum: {
							style: 'filter-input-wrapper',
							id: 'gridStockContext_RegNo',
							placeholder: 'Registration number',
							context: 'gridStockContext'
						},
						RefNum: {
							style: 'filter-input-wrapper',
							id: 'gridStockContext_RefNo',
							placeholder: 'Ref number',
							context: 'gridStockContext'
						},
						DateFrom: {
							style : 'input-append date filter-input-wrapper-date mobile-width12p dfrom',
							title: '&nbsp; Date created',
							id: 'gridStockContext_DateFrom',
							placeholder: 'From',
							context: 'gridStockContext',
							append: '<i class="icon-calendar"></i>',
							readonly: true,
							bind: function() {
								$('#gridStockContext_DateFrom').change(function() {
									_w.tcstock.dFrom = $(this).val();
								});
							}
						},
						DateTo: {
							style : 'input-append date filter-input-wrapper-date mobile-width12p dto',
							id: 'gridStockContext_DateTo',
							placeholder: 'To',
							context: 'gridStockContext',
							append: '<i class="icon-calendar"></i>',
							readonly: true,
							bind: function() {
								$('#gridStockContext_DateTo').change(function() {
									_w.tcstock.dTo = $(this).val();
								});
							}
						},
						Buttons: {
							actions: true,
							clearId: 'clearStockGridContext',
							bindClear: _w.tcstock.clearStockGridContext,
							searchId: 'searchStockGrid',
							bindSearch: _w.tcstock.searchStockGrid
						}
					}
				},
				'gridColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Company: {
							id: 'gridStockColumn_Company',
							title: 'DEALERSHIP',
							orderAsc: {
								id: 'gridStockOrder_CompanyAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_CompanyDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'company.name', 'DESC')
							}
						},
						VIN: {
							id: 'gridStockColumn_VIN',
							title: 'VIN',
							orderAsc: {
								id: 'gridStockOrder_VinAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.vinNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_VinDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.vinNumber', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						Make: {
							id: 'gridStockColumn_Make',
							title: 'MAKE',
							orderAsc: {
								id: 'gridStockOrder_MakeAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_MakeDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'make.name', 'DESC')
							}
						},
						Model: {
							id: 'gridStockColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridStockOrder_ModelAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_ModelDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'model.name', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						Type: {
							id: 'gridStockColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridStockOrder_TypeAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_TypeDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'type.name', 'DESC')
							},
							style: 'type'
						},
						Year: {
							id: 'gridStockColumn_Year',
							title: 'YEAR',
							orderAsc: {
								id: 'gridStockOrder_YearAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'vehicleYear.name', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_YearDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'vehicleYear.name', 'DESC')
							},
							style: 'year'
						},
						KM: {
							id: 'gridStockColumn_KM',
							title: 'KM&#39;S',
							orderAsc: {
								id: 'gridStockOrder_KmAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.km', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_KmDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.km', 'DESC')
							},
							style: 'kms hidden-phone hidden-tablet'
						},
						Trade: {
							id: 'gridStockColumn_Trade',
							title: 'TRADE',
							orderAsc: {
								id: 'gridStockOrder_TradeAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.tradePrice', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_TradeDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.tradePrice', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						Retail: {
							id: 'gridStockColumn_Retail',
							title: 'RETAIL',
							orderAsc: {
								id: 'gridStockOrder_RetailAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.retailPrice', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_RetailDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.retailPrice', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
                        List: {
                            id: 'gridStockColumn_List',
                            title: 'NEW LIST PRICE',
                            orderAsc: {
                                id: 'gridStockOrder_ListAsc',
                                bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.listPrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_ListDesc',
                                bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.listPrice', 'DESC')
                            },
                            style: 'hidden-phone hidden-tablet'
                        },
						Bid: {
							id: 'gridStockColumn_Bid',
							title: 'BID',
							orderAsc: {
								id: 'gridStockOrder_BidAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.highestBid', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_BidDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.highestBid', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						Status: {
							id: 'gridStockColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridStockOrder_JobstateAsc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridStockOrder_JobstateDesc',
								bind: $.proxy(_w.tcstock.orderStockGrid, this, 'stock.jobState', 'DESC')
							}


						}
					}
				},
				'gridColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Company: {
							id: 'gridStockFilter_Company',
							context: 'gridStockFilter',
							dataStoreId : 'tcdealers',
							selectEmpty : 'All'
						},
						VIN: {
							id: 'gridStockFilter_VIN',
							context: 'gridStockFilter'
						},
						Make: {
							id: 'gridStockFilter_Make',
							context: 'gridStockFilter'
						},
						Model: {
							id: 'gridStockFilter_Model',
							context: 'gridStockFilter'
						},
						Type: {
							id: 'gridStockFilter_Type',
							context: 'gridStockFilter'
						},
						Year: {
							id: 'gridStockFilter_Year',
							context: 'gridStockFilter'
						},
						KM: {
							id: 'gridStockFilter_KM',
							context: 'gridStockFilter'
						},
						Trade: {
							id: 'gridStockFilter_Trade',
							context: 'gridStockFilter'
						},
						Retail: {
							id: 'gridStockFilter_Retail',
							context: 'gridStockFilter'
						},
						Bid: {
							id: 'gridStockFilter_Bid',
							context: 'gridStockFilter'
						},
						Status: {
							id: 'gridStockFilter_Status',
							context: 'gridStockFilter',
							dataStoreId : 'stockstatuses',
							selectEmpty : 'All'
						}
					}
				},
				'gridRowRepeater': {},
				'gridPager': {}
			});

			// Retrieve initial grid data.
			if (null == App.API.taskContract('gridTCStock'))
			{
				App.API.getTask(
						'gridTCStock', 'Stock', 'Stock.TradeCenterGrid', null,
						{}, _w.tcstock.loadStockGrid, _w.taskContractError
						);
			}
			else
			{
				_w.tcstock.loadStockGrid( null, {}, {} );
			}
		},

		onStockPublished : function()
		{
			$(".gridStockFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#searchStockGrid').click();
				}
			});

			$(".gridStockContext").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#searchStockGrid').click();
				}
			});

			var _p = App.permissions;
			var _createStockDisabled = false == _p.stockCreateNew && false == _p.stockCreateAuction
									 ? true : false;
			$('#newStock').prop('disabled', _createStockDisabled);
			$('#exportStockGrid').prop('disabled', !App.permissions.stockGridExport);
			App.Event.listen('stockGridSuFilter', 'SuChange', $.proxy(_w.tcstock.loadStockGrid, this), 'Recurring');
			$('.dfrom').datepicker({format:"yyyy-mm-dd"});
			$('.dto').datepicker({format:"yyyy-mm-dd"});
			$('#gridStockContext_DateFrom').val(_w.tcstock.dFrom);
			$('#gridStockContext_DateTo').val(_w.tcstock.dTo);

			setTimeout(_w.tcstock.refreshGrid, 120000);
		},

		refreshGrid : function()
		{
			if ('stock' != App.activePage)
			{
				return;
			}
			_w.tcstock.loadStockGrid( null, {}, {} );
			setTimeout(_w.tcstock.refreshGrid, 120000);
		},

		pageStockGrid : function( page )
		{
			_w.tcstock.loadStockGrid( {}, {"Grid":{"Page":page}} );
		},

		loadStockGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridTCStock', data, options,
					_w.tcstock._onStockGridDataReceived, _w.taskExecError
					);
		},

		_onStockGridDataReceived : function( response )
		{
			_w.tcstock.ti.hydrateParam('gridRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'stock.registrationNumber': 'gridStockContext_RegNo',
				'stock.referenceNumber': 'gridStockContext_RefNo',
				'company.id': 'gridStockFilter_Company',
				'stock.vinNumber': 'gridStockFilter_VIN',
				'make.name': 'gridStockFilter_Make',
				'model.name': 'gridStockFilter_Model',
				'type.name': 'gridStockFilter_Type',
				'vehicleYear.name': 'gridStockFilter_Year',
				'stock.km': 'gridStockFilter_KM',
				'stock.tradePrice': 'gridStockFilter_Trade',
				'stock.retailPrice': 'gridStockFilter_Retail',
                'stock.listPrice': 'gridStockFilter_List',
				'stock.highestBid': 'gridStockFilter_Bid',
				'stock.jobState': 'gridStockFilter_Status'
			});
			$('select.gridStockFilter').each(function(i, elem) {
				$(elem).selectpicker('refresh');
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: ('Trade Center' == row.jobState) ? 'tcstockview' : 'limitedtcstockview',
					prepend: {
						Trade  : 'R ',
						Retail : 'R ',
						Offer  : 'R '
					},
					style: {
						VIN   	: 'hidden-phone hidden-tablet',
						Model 	: 'hidden-phone hidden-tablet',
						KM    	: 'kms hidden-phone hidden-tablet',
						Trade   : 'hidden-phone hidden-tablet',
						Retail  : 'hidden-phone hidden-tablet',
						Bid   	: 'hidden-phone hidden-tablet'
					},
					items: {
						'id'      : row.id,
						'Company' : row.company.name,
						'VIN'     : row.vinNumber,
						'Make'    : row.type.model.make.name,
						'Model'   : row.type.model.name,
						'Type'    : row.type.name,
						'Year'    : row.vehicleYear.name,
						'KM'      : row.km,
						'Trade'   : row.tradePrice,
						'Retail'  : row.retailPrice,
                        'List'   : row.listPrice,
						'Bid'     : row.highestBid,
						'Status'  : row.auction.jobState == 'Undone' || row.auction.jobState == 'Relist' ? 'Relist' : row.jobState
				}
				});
			}
			_w.tcstock.ti.hydrateParam('gridRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'stockPager';
			response.Data.Meta.bind = _w.tcstock.pageStockGrid;
			_w.tcstock.ti.hydrateParam('gridPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		exportStockGrid : function()
		{
			App.API.execTask(
					'gridTCStock', {}, {'ExportToExcel': true},
					_w.tcstock._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		newStock : function()
		{
			window.location.hash = '/tcstockview?id=0';
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
            win.document.write(response);
		},

		clearStockGridContext : function()
		{
			try
			{
				$('select.gridStockFilter').each(function(i, elem) {
					$(elem).selectpicker('val', '');
					$(elem).selectpicker('refresh');
				});
			}
			catch (err) { console.log(err); }
			$('.gridStockContext').val('');
			$('.gridStockFilter').val('');
			_w.tcstock.searchStockGrid(true);
		},

		searchStockGrid : function(resetOrder)
		{
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridStockContext_RegNo', 'stock.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridStockContext_RefNo', 'stock.referenceNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridStockContext_DateFrom', 'stock.created', '>=');
			filter = _w.filterIfnotEmpty(filter, 'gridStockContext_DateTo', 'stock.created', '<=', ' 23:59:59');

			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Company', 'company.id');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_VIN', 'stock.vinNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Make', 'make.name');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Year', 'vehicleYear.name');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_KM', 'stock.km');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Trade', 'stock.tradePrice');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Retail', 'stock.retailPrice');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_List', 'stock.listPrice');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Offer', 'stock.highestOffer');
			filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Status', 'stock.jobState');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			if (resetOrder)
			{
				request.Grid.OrderBy = {'stock.created': 'DESC'};
			}
			_w.tcstock.loadStockGrid( null, request, {} );
		},

		orderStockGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.tcstock.loadStockGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();